!
! average catalog of images
! 
! use via
! COMPUTEAVE prefix = catalog [int] [meth] 
!  with
!      prefix   : prefix for averaged frame
!      catalog  : catalog with frames to be averaged
!      int      : interval im catalog lo,hi
!      meth     : 1 = mean, 2 = weighted mean, 3 = median
!
define/para p1 ? C "outframe:"
define/para p3 ? C "Catalog name: " 
define/para p4 1,999 N "Enter catalog interval lo,hi : "
define/para p5 2 N "Method, 1=mean 2=weighted mean 3=median: " 
!
define/local catal/i/1/1 0
define/local ima/i/1/1 0
define/local int/i/1/2 {p4}
define/local count/i/1/1 0
define/local sdev/d/1/1 0.
define/local snr/r/1/1 0.
define/local sdevsum/d/1/1 0.
define/local signull/r/1/1 0.
define/local exist/i/1/1 0
!
if {p5} .eq. 3 then 
 goto median
endif
!
if {p5} .eq. 2 then 
 goto wmean
endif
!
if {p5} .eq. 1 then 
 goto mean
endif
!
write/out "unknown method"
goto end
!
median:
write/out "using average/image with median option "
average/ima {p1}MED = {p3} M + median,0.900,1.100,DATA
write/out "median spectrum is stored in {p1}MED "
goto end
!
mean:
!
!   \[ \bar{S_i} = \frac{1}{N}\sum_j=1^N S_{ij}  \]
!
write/out "using dumb mean of images"
! find the first catalog entry
start:
store/frame in_a {p3} 1 finish
ima = ima+1
if ima .eq. {int(1)} then
 write/out #{ima} {in_a}
 count = count+1
 comp/ima &x = {in_a}
 goto next
endif
goto start
!
next:
store/frame in_a {p3} 1 finish
ima = ima+1
if ima .ge. {int(1)} .and. ima .le. {int(2)} then
 write/out #{ima} adding {in_a}
 count = count+1
 comp/ima &x = &x+{in_a}
! comp/ima &y = &x/{ima}
! plo {in_a}
! over &y
endif
goto next
!
finish:
comp/ima {p1}AVE = &x/{count}
write/out "average spectrum is stored in {p1}AVE "
dele/ima &x no
goto end
!
wmean:
!
!  \[ \bar{S_i} = \frac{1}{N}\sum_{j=1}^N w_j S_{ij}  \]
! with
!  \[ w_j = \left(frac{\sigma_0}{\sigma_{cj}}\right) \]  
!  \[ \sigma_{cj} = 1/(S/N)_j \quad\mbox{measured in the continuum} \]  
!  \[ \sigma_0^2 = \left[\frac{1}{N}\sum_{j=1}^N\sigma_{cj}^{-2}\right]^{-1} \]
!
write/out "using weighted mean of images"
! find the first catalog entry
wstart:
store/frame in_a {p3} 1 wfinish
! check for existence of descriptor sdev in first frame
comp/key exist = M$EXISTD("{in_a}","SDEV")
if {exist} .eq. 0 then
 statist/ts {p3}
endif
!
ima = ima+1
if ima .eq. {int(1)} then
 copy/dk {in_a} SDEV/d/1/1 sdev/d/1/1
 sdevsum = 1/(sdev*sdev)
 write/out "#{ima} {in_a}/({sdev}*{sdev})"
 comp/ima &x = {in_a}/({sdev}*{sdev})
 count = count+1
 goto wnext
endif
goto wstart
!
wnext:
store/frame in_a {p3} 1 wfinish
ima = ima+1
if ima .ge. {int(1)} .and. ima .le. {int(2)} then
 copy/dk {in_a} SDEV/d/1/1 sdev/d/1/1
 sdevsum = sdevsum + 1/(sdev*sdev)
 write/out "#{ima} adding {in_a}/({sdev}*{sdev})"
 comp/ima &x = &x+{in_a}/({sdev}*{sdev})
 count = count+1
endif
goto wnext
!
wfinish:
signull = 1/(sdevsum/count)
comp/ima {p1}WAVE = {signull}*&x/{count}
write/out "weighted average spectrum is stored in {p1}WAVE "
snr = 1/(m$sqrt(signull))
write/out "the rms S/N of this time series is {snr}"
dele/ima &x no
goto end
!
end:
