! @@ computeTVC.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  computeTSC.prg  
! A. Kaufer	940506
! 
! compute a 'time scale spectrum' TSC as
!
! \[ (TSC)_i=2*(T_N-T_1)\sum_{j=1}^{N-1}\left|\Theta(S_{ij}-\bar{s_i})-
!		\Theta(S_{ij+1}-\bar{s_i})\right| \]
! with 	$S_{ij}$ normalized intensity of the $i$th pixel in the $j$th spectrum
!	$\bar{s_i}$ the mean normalized intensity	 
!	$T_j$ date of exposure of $j$th spectrum 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! use as
! COMPUTETSC prefix = catalog
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ? C "Enter result spectra prefix : "
define/par p3 ? C "Enter catalog.cat : "
!
define/local tmpname/c/1/40 " " all
define/local infile1/c/1/40 " " all
define/local infile2/c/1/40 " " all
define/local catal/i/1/1 0 
define/local ind/i/1/1 0 
define/local sdev/r/1/1 0.0
define/local sdevsum/r/1/1 0.0
define/local N/i/1/1 0
define/local exist/i/1/1 0
define/local tstart/d/1/1 0.
define/local tend/d/1/1 0.

define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

!
ind = m$index("{p3}",".cat")-1
write/key cat/c/1/40 " " all
write/key cat/c/1/{ind} {p3}/c/1/{ind}
comp/key exist = M$EXIST("{cat}AVE.{mid$types(1:{extlen1})}")
if {exist} .eq. 0 then
 average/ts &AV = {p3}
else
 comp/ima &AVWAVE = {cat}WAVE
endif
create/ima &TSC = &AVWAVE POLY 0,0
!
store/frame tmpname {p3} 1 finish
ind = m$index(tmpname,".{mid$types(1:{extlen1})}")-1
write/key infile1/c/1/40 " " all
write/key infile1/c/1/{ind} {tmpname}/c/1/{ind}
copy/dk {infile1} dtime/d/4/1 tstart/d/1/1 
!
next:
N = N+1
store/frame tmpname {p3} 1 finish
ind = m$index(tmpname,".{mid$types(1:{extlen1})}")-1
write/key infile2/c/1/40 " " all
write/key infile2/c/1/{ind} {tmpname}/c/1/{ind}
copy/dk {infile2} dtime/d/4/1 tend/d/1/1 
!
write/out "#{N}, files {infile2}, {infile1}"
!
compute/ima &S2   = {infile2}-&AVE
compute/ima &S1   = {infile1}-&AVE
!
replace/ima &S1 &sign1 <,0.0=0.0,1.0
replace/ima &S2 &sign2 <,0.0=0.0,1.0
!
compute/ima &TSC = &TSC + ABS(&sign1-&sign2)
!
!plo &TSC
compute/ima &plo = 2*({tend}-{tstart})/&TSC
plo &plo
!
infile1 = infile2
goto next
finish:
compute/ima {p1}TSC = 2*({tend}-{tstart})/&TSC
plo {p1}TSC
!
dele/temp
write/out " The TSC spectrum is stored in {p1}TSC"
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
