! @@ computeTVC.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  computeTVS.prg  
! A. Kaufer	940506
! 
! compute the variability statistics, the 'Temporal Variance Spectrum'
! as suggested by Alex Fullerton
! \[ (TVS)_i=\sigma_0^2\frac{1}{N-1}\sum_{j=1}^N\left(\frac{S_{ij}-\bar{S}_i}
!		{\sigma_{jc}\sqrt{S_{ij}}}\right)^2 \]
! with $S_{ij}$ normalized intensity of the $i$th pixel in the $j$th spectrum
!      $\bar{S}_i$ the weighted mean of the normalized intensity	 
!      $\sigma_{jc}$ inverse of $S/N$ of spectrum $j$ measured in 
!			a continuum band
!      $\sigma_0^2 = \left[\frac{1}{N}\sum_{j=1}^N\sigma_{cj}^{-2}\right]^{-1}$
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! use as
! COMPUTETVS prefix = catalog
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ? C "Enter result spectra prefix : "
define/par p3 ? C "Enter catalog.cat : "
!
define/local tmpname/c/1/40 " " all
define/local infile/c/1/40 " " all
define/local catal/i/1/1 0 
define/local ind/i/1/1 0 
define/local sdev/r/1/1 0.0
define/local sdevsum/r/1/1 0.0
define/local signull/r/1/1 0.0
define/local N/i/1/1 0
define/local exist/i/1/1 0
define/local los/r/1/1 0.

define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

!
store/frame tmpname {p3} 1 finish
comp/key exist = M$EXISTD("{tmpname}","SDEV")
if {exist} .eq. 0 then
 statist/ts {p3}
endif
!
ind = m$index("{p3}",".cat")-1
write/key cat/c/1/40 " " all
write/key cat/c/1/{ind} {p3}/c/1/{ind}
comp/key exist = M$EXIST("{cat}WAVE.{mid$types(1:{extlen1})}")
if {exist} .eq. 0 then
 write/out "have to compute weighted average first"
 average/ts {cat} = {p3} ? 2
endif
comp/ima &AVE = {cat}WAVE
create/ima &TVS = &AVE POLY 0,0
!
next:
N = N+1
store/frame tmpname {p3} 1 finish
ind = m$index(tmpname,".{mid$types(1:{extlen1})}")-1
write/key infile/c/1/40 " " all
write/key infile/c/1/{ind} {tmpname}/c/1/{ind}
!
copy/dk {infile} SDEV/d/1/1 sdev
write/out "#{N}, file {infile}, sdev = {sdev}"
sdevsum = sdevsum+1/(sdev*sdev)
!
compute/ima &S   = {infile}
compute/ima &sqrtS = SQRT(&S)
compute/ima &TVS = &TVS + ((&S-&AVE)/({sdev}*&sqrtS))**2
!
!signull = 1/(sdevsum/N)
!compute/ima &plo = {signull}*1/({N}-1)*&TVS
!plo &plo
!
goto next
finish:
signull = 1/(sdevsum/N)
compute/ima {p1}TVS = {signull}*1/({N}-1)*&TVS
!
inputi(1) = N-1
inputr(1) = 0.05
RUN TSEXEC:chisqrdistpp
los = signull*outputr(1)/(N-1)
write/out "Level of significance for a probability of 95 percent = {los}"
copy/kd los {p1}TVS los/r/1/1 
!
compute/ima {p1}RMS = 100*SQRT({p1}TVS)
los = 100*m$sqrt(los)
copy/kd los {p1}RMS los/r/1/1 
!
dele/temp 
!
write/out " The TV spectrum is stored in {p1}TVS, the RMS spectrum in {p1}RMS"
!
end:
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
