! @@ creamasktempl
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  creamasktempl.prg  
! A. Kaufer	951212
! 
! purpose 
!  create template and mask for xcorrelation (tscorel.prg) 
!
! use via
! CREAMASKTEMPL linetable
!  with    
!      linetable :  table with lines in cols :lambda :wcal
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!
define/para p1 ? TAB " Enter table with lines in cols :lambda :wcal "
define/para p2 300 N " Enter width of mask in velocity "
!
! create mask for individual lines e.g. Balmer lines
!
define/local i/i/1/1 0
define/local wave/r/1/1 0.0
define/local vel/r/1/1  {p2} 
define/local xs/r/1/1 0. 
define/local xe/r/1/1 0. 

define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

!crea/ima &mask 1,47000 3400,0.12 POLY 1,0,0
crea/ima &mask 1,56000 3400,0.10 POLY 1,0,0  ! HEROS

!write/ima &mask [<:4100] 0. ALL
!write/ima &mask [6600:>] 0. ALL

write/ima &mask [5405:5846] 0. ALL           ! HEROS 
!
! mask Balmer lines
!
write/out "Mask Balmer lines 1 - 36"
copy/tab  TSDATA:balmer &balmer
do i = 1  36
 wave = {&balmer,:lambda,{i}}
 xs = wave*(1-vel/3.e5)
 xe = wave*(1+vel/3.e5)
 write/ima &mask [{xs}:{xe}] 0. ALL
enddo

!
! create template as delta peaks from synthetic lines list
! create mask for continuum regions between lines
!
define/local lam/r/1/1 0. 
define/local int/r/1/1 0. 
define/local max/r/1/1 0.

!crea/ima &comb     1,47000 3400,0.12 POLY 1,0,0
!crea/ima &combmask 1,47000 3400,0.12 POLY 0,0,0
crea/ima &comb     1,56000 3400,0.10 POLY 1,0,0  ! HEROS
crea/ima &combmask 1,56000 3400,0.10 POLY 0,0,0  ! HEROS

copy/tab {p1} &a
copy/dk middumma.{mid$types(9:{extlen2})} tblcontr/i/4/1 imax/i/1/1
stat/tab &a :wcal
max = outputr(2)

do i = 1  {imax}
 lam = {&a,:lambda,@{i}}
 int = {&a,:wcal,@{i}}
 int = 1.-int/max
 write/ima &comb {lam},1 {int} ALL
 write/out "{i}, {imax} {lam} {int}"
 dele/descr &comb HISTORY

 xs = lam*(1-vel/3.e5)
 xe = lam*(1+vel/3.e5)
 write/ima &combmask [{xs}:{xe}] 1. ALL
 dele/descr &combmask HISTORY
enddo

copy/ii &comb templ_{p1}
compute/ima mask_{p1} = &mask*&combmask

comp/ima &zz = (templ_{p1}-1.)*mask_{p1}
replace/ima &zz &yy -1,-0.001=-1
write/out " " 
write/out " -----------------------------------------------" 
write/out " Number of lines for xcorrelation: {outputi(15)}"
write/descr templ_{p1} nlines/i/1/1 {outputi(15)}

write/out " template stored in templ_{p1} "
write/out " mask     stored in  mask_{p1} "

dele/temp
