!
! overplot frames from a catalog, offset proportional to time
!
! use via
!
! @@ plotts cat scale lam_int cat_int
!
! with 
!  	cat       = catalog
! 	scale     = scale (units/day)
! 	lam_int   = wavelength interval start,end
! 	cat_int   = catalog interval first,last
!
define/para  p1 ? ? "Cat name: " 
define/para  p2 ? ? "Scale (units/day): " 
define/para  p3 6555,6570 ? "Wavelength interval start,end: " 
define/para  p4 1,999 ? "Catalog interval first,last: " 
!
define/local offset/r/1/1 0.
define/local catal/i/1/1 0
define/local ind/i/1/1 0
define/local time0/r/1/1 0.
define/local time1/r/1/1 0.
define/local time/r/1/1 0.
define/local timey1/r/1/1 0.
define/local timey2/r/1/1 0.
define/local int/r/1/2 {p4}
define/local span/r/1/1 0.
define/local scale/r/1/1 {p2}
define/local exist/i/1/1 0
!
! find time of first and last catalog entry
ind = 0
next:
store/frame in_a {p1} 1 last
ind = {ind}+1
if {ind} .lt. {int(1)} goto next
if {ind} .ge. {int(2)} goto last
if {ind} .eq. {int(1)} then
exist = m$existd(in_a,dtime)
if {exist} .eq. 1 then
cop/dk {in_a} dtime/d/4/1 time0/r/1/1
else
 cop/dk {in_a} o_time/d/4/1 time0/r/1/1
 endif
endif
goto next
last:
exist = m$existd(in_a,dtime)
if {exist} .eq. 1 then
cop/dk {in_a} dtime/d/4/1 time1/r/1/1
else
cop/dk {in_a} o_time/d/4/1 time1/r/1/1
endif
span = time1 - time0
set/form F8.2
write/out "Time interval: JD24{time0}-JD24{time1}"
set/form
!
catal =  0
ind = 0
next1:
store/frame in_a {p1} 1 finish
ind = {ind}+1
if {ind} .lt. {int(1)} goto next1
if {ind} .gt. {int(2)} goto finish
if {ind} .eq. {int(1)} then
 timey1 = {time0}-0.1*{span}
 timey2 = {time1}+0.1*{span}
! timey1 = {time0}-1./{scale}
! timey2 = {time1}+1./{scale}
 offset = {time0}-1./{scale}
 set/gra xa={p3} ya={timey1},{timey2} 
 plo/axes ? ? ? "Wavelength [\AA ]" "JD-2400000.5"
 copy/ii {in_a} &a
 comp &xxx = &a/{scale}
! comp &xxx = {in_a}/{scale}
 over &xxx ? ? {offset}
else
exist = m$existd(in_a,dtime)
if {exist} .eq. 1 then
 cop/dk {in_a} dtime/d/4/1 time/r/1/1
 else
 cop/dk {in_a} o_time/d/4/1 time/r/1/1
 endif
 copy/ii {in_a} &a
 comp &xxx = &a/{scale}
! comp &xxx = {in_a}/{scale}
 offset = {time}-1/{scale}
 over &xxx ? ? {offset}
endif
goto next1
!
finish:
exit:
dele/temp
