!
! extracts spectral line from frame
! @@ SPECL frame subframe wavelength,startvelocity,endvelocity
!
DEFINE/PAR P1 ? I "input image:"
DEFINE/PAR P2 ? I "output image:"
DEFINE/PAR P3 ? N "wavelength,vel_lo,vel_hi:"
DEFINE/PAR P4 0 N "velocity offset:"
!
DEFINE/LOCAL PARA/D/1/3 {P3}
DEFINE/LOCAL WAVE/D/1/7 0. ALL
WAVE(7) = 2.997925D5
!
COMPUTE/KEY PARA(1) = PARA(1)*(1.+{p4}/WAVE(7))
!
COMPUTE/KEY WAVE(1) = (PARA(2)/WAVE(7)*PARA(1))+PARA(1)  ! start wavelength
COMPUTE/KEY WAVE(2) = (PARA(3)/WAVE(7)*PARA(1))+PARA(1)  ! end wavelength
!
EXTRACT/IMA {P2} = {P1}[{WAVE(1)}:{WAVE(2)}]       ! extract subframe
!
COPY/DK {P2} START WAVE/D/3/1               ! copy actual values of start 
COPY/DK {P2} STEP  WAVE/D/4/1               ! and step
!
COMPUTE/KEY WAVE(5) = (WAVE(3)-PARA(1)) / PARA(1) * WAVE(7) ! start and 
COMPUTE/KEY WAVE(6) = WAVE(4) / PARA(1) * WAVE(7)  ! step in velocity space
!
COPY/KD WAVE/D/5/1 {P2} START                      ! copy start and 
COPY/KD WAVE/D/6/1 {P2} STEP                       ! step 
!
WRITE/DESC {P2} CUNIT/C/17/32  "VELOCITY"          ! write label
WRITE/DESC {P2} CUNIT/C/1/16   "FLUX"              ! write label
!