! @@ ts2strfct.prg
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!
! TS2STRFCT.PRG
! A.KAUFER - LSW Heidelberg
! AK            941017  first version
!
! .PURPOSE  
!
! execute the command :
! TS2STRFCT out = inframes x_intv [t_intv] [vstep] 
!  where
!      inframes  :  catalog.cat (time series)
!      outimage  :  prefix for outimages 
!      x_interval: lambda_center,v_low,v_high of velocity interval 
!      t_interval: cat_entry_start,cat_entry_stop, defaulted to all 
!      vstep : velocity step for rebinning
!
DEFINE/PAR P1 ? IMA "Enter prefix for outframes (veloc - freq frame) : "
DEFINE/PAR P3 ? C   "Enter catalog.cat with 1-dim frames    : "
DEFINE/PAR P4 ? N   "Enter central wavelength and velocity interval lamc,vlo,vhi: "
DEFINE/PAR P5 0,0 N "Enter valid catalog interval tlo,thi : "
DEFINE/PAR P6 5   N "Enter valid velocity step : "
DEFINE/PAR P7 ?   N "Enter column : " 
! 
define/local col/i/1/1 {p7}
define/local cols/i/1/1 0
define/local iii/i/1/1 0
define/local jjj/i/1/1 0
define/local count/i/1/1 0
define/local ndata/i/1/1 0

define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

!
! convert time series in table with columns for each velocity step
!
vtable/ts middummtab = {p3} {p4} {p5} {p6} Y Y 
!
crea/tab &work 2 1000
crea/col &work :time " " G8.3 R*8
copy/tt  &tab  :jd24 &work :time
crea/col &work :value " " G8.3 R*8
!
! create the velocity - frequency frame for the results of transformation
!
write/out "---------------------------------------------"
copy/dk &tab.{mid$types(9:{extlen2})} vnpix/i/1/1 cols
write/out "{cols} velocity data points found"
copy/dk &tab.{mid$types(9:{extlen2})} tblcontr/i/4/4 ndata
write/out "{ndata} time data points found"
write/out "---------------------------------------------"
!
! create table for structure function
!
crea/tab &tabf 2 10000
crea/col &tabf :dt " " D12.4 R*8
crea/col &tabf :dI " " D12.4 R*8
!
! compute structure function
!
!col = 60
write/out {col}
copy/tt &tab :l{col} &work :value
do jjj = 1 {ndata} 1
 write/out "processing {jjj} of {ndata} "
 do iii = {jjj} {ndata} 1
!
! loop over data in table
!
 count = count+1
 &tabf,:dt,@{count} = {&work,:time,@{iii}}-{&work,:time,@{jjj}}
 &tabf,:dI,@{count} = {&work,:value,@{iii}}-{&work,:value,@{jjj}}
!
 enddo
enddo
!
copy/tab &tabf {p1}
!dele/temp
end:


