! @(#)tsasin.prg	5.1 (ESO-IPG) 4/5/93 15:59:25
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
!.COPYRIGHT (c)  1992     European Southern Observatory and Warsaw Observatory
!.IDENT     tsasin.prg
!.AUTHOR    Alex Schwarzenberg-Czerny, ESO and Warsaw Observatory 
!.KEYWORD   MIDAS, time analysis, SINEFIT/TSA
!.LANGUAGE  MIDAS
!.PURPOSE   Fit sine (Fourier) series, return residuals 
!.VERSION   0.0               June 1992
!.RETURNS   None  
!.ENVIRON   TSA context
!-----------------------------------------------------------------------------
!
!   Get parameters
!
CROSSREF INTAB OUTTAB FREQUE ORDERTSA ITER
DEFINE/PAR P1 {INROOT1} TABLE  "Enter input table: "
DEFINE/PAR P2 {OUTROOT} TABLE  "Enter output table: "
DEFINE/PAR P3 {STARTTSA}   NUMBER "Enter approximate frequency: "
DEFINE/PAR P4 {ORDERTSA}   NUMBER "Enter order (1 for pure sine): "
DEFINE/PAR P5 1         NUMBER "Enter No. of iterations (<0 to continue): "
!
WRITE/KEY  ITER/I/1/1     {P5}
!
!   Ignore {P1} to {P4} by continuation
!
IF ITER .GT. 0 THEN
  WRITE/KEY  INROOT1/C/1/60   {P1}
  WRITE/KEY  OUTROOT/C/1/60   {P2}
  WRITE/KEY  STARTTSA/D/1/1  {P3}
  WRITE/KEY  ORDERTSA/I/1/1  {P4}
!
  IF ORDERTSA .LT. 0 THEN
    WRITE/KEY ORDERTSA/I/1/1 0
    WRITE/OUT *** Wrong ORDERTSA, set to 0
  ELSEIF ORDERTSA .GT. 9 THEN
    WRITE/KEY ORDERTSA/I/1/1 9
    WRITE/OUT *** Wrong ORDERTSA, set to 9
  ENDIF
!
  SELECT/TAB {INROOT1}    SELECT.AND.:TIME.NE.NULL.AND.:VALUE.NE.NULL
  OUTPUTI(2) = ORDERTSA*2+1
  IF OUTPUTI(1) .LE. OUTPUTI(2) THEN
    WRITE/OUT *** Too few selected/correct data or too large ORDERTSA
    RETURN/EXIT
  ENDIF
  COPY/TAB   {INROOT1}        {OUTROOT}
  COMPUTE/TABLE {OUTROOT} :ORIG_VALUE = :VALUE
ELSE
  COMPUTE/TABLE {OUTROOT} :VALUE = :ORIG_VALUE
ENDIF
!
!   Call routine
!
WRITE/KEY  IN_A/C/1/60  {OUTROOT}
WRITE/KEY  OUT_A/C/1/60 {OUTROOT}
WRITE/KEY  HISTORY      "SINEFIT/TSA"
RUN TSEXEC:TSASIN
COMPUTE/TABLE {OUT_A} :FIT = :ORIG_VALUE-:VALUE
!
!   Fit results are stored in STARTTSA and OUTPUTD
!
WRITE/OUT *** Call no other TSA commands and preserve OUTPUTD to continue 
WRITE/OUT *** by repeating SINEFIT/TSA with negative number of iterations
!
!
!   End of tsasin
!
