!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! TSCORAVEL.PRG
!
!
!
DEFINE/PARAMETER P1 ? C " Catalog of spectra : "
DEFINE/PARAMETER P2 ? C " Template spectrum  : "
DEFINE/PARAMETER P3 ? C " Mask spectrum      : "
DEFINE/PARAMETER P4 ? C " Output table       : "
!
DEFINE/LOCAL SSIZE/D/1/1 0.
DEFINE/LOCAL WAVE/D/1/3 0. ALL
DEFINE/LOCAL FACT/D/1/1 0.
DEFINE/LOCAL N/I/1/1 0
define/local num/i/1/1 0
define/local mean/r/1/1 0
define/local var/r/1/1 0
!
define/local tmpname/c/1/40 " " all
define/local infile/c/1/40 " " all
!
define/local catal/i/1/1 0
define/local ind/i/1/1 0
!
define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

crea/tab &win 3 2
crea/col &win :XSTART
crea/col &win :XEND
&win,:XSTART,@1 = -25.0
&win,:XEND,@1   =  25.0
&win,:XSTART,@2 = -50.0
&win,:XEND,@2   =  50.0
&win,:XSTART,@3 = -10.0
&win,:XEND,@3   =  10.0
read/tab &win
!
CREA/ICAT {p4}.cat NULL
!
crea/tab {p4}
crea/col {p4} :jd24 ? D12.5 R*8
crea/col {p4} :vxcor ? F8.3 R*4
!
! modify template
COP/DK {p2} START/D/1/1 WAVE/D/1/1
COP/DK {p2} STEP/D/1/1 WAVE/D/3/1
COP/DK {p2} NPIX/I/1/1 N/I/1/1
COMP/KEY WAVE(2) = {WAVE(1)}+({N}-1)*{WAVE(3)}    ! LAST WAVE
comp/ima MASK = {p3}
!
repl/ima {p2} TEMPL 0.0,0.001=1.
stat/ima TEMPL
mean = outputr(3)
var = outputr(4)
COMP/IMA TEMPLM = (TEMPL - {mean})/{var}
comp/ima TEMPLM =TEMPLM*MASK
stat/ima TEMPLM
mean = outputr(3)
var = outputr(4)
COMP/IMA TEMPLM = (TEMPLM - {mean})/{var}
!set/gra xa ya
!plo TEMPLM
!
SET/GRA pmode=1 xa=-300,300 ya=-500,1800 color=1
plot/axes
!
! Loop through catalog
next:
store/frame tmpname {p1} 1 finish
ind = m$index(tmpname,".{mid$types(1:{extlen1})}")-1
num = num+1
write/key infile/c/1/40 " " all
write/key infile/c/1/{ind} {tmpname}/c/1/{ind}
write/out {infile}
copy/dk {infile} dtime/d/4/1 jd24/d/1/1
{p4},:jd24,@{num} = {jd24} 
!
! now the operation on the catalog
!
COP/DK {infile} START/D/1/1 WAVE/D/1/1
COP/DK {infile} STEP/D/1/1 WAVE/D/3/1
COP/DK {infile} NPIX/I/1/1 N/I/1/1
COMP/KEY WAVE(2) = {WAVE(1)}+({N}-1)*{WAVE(3)}    ! LAST WAVE
!
comp/ima MASK = {p3}
!
stat/ima {infile} 
mean = outputr(3)
var = outputr(4)
COMP/IMA SPECM = ({infile} - {mean})/{var}
comp/ima SPECM = SPECM*MASK
stat/ima SPECM 
mean = outputr(3)
var = outputr(4)
COMP/IMA SPECM = (SPECM - {mean})/{var}

assign/gra g,1
set/gra
plot SPECM
!
WRITE/OUT "computing logarithm of wavelength-axis... "
COMP/KEY WAVE(1) = M$LN({WAVE(1)})                ! FIRST WAVE
COMP/KEY WAVE(2) = M$LN({WAVE(2)})                ! LAST WAVE
COMP/KEY N = 2*{N}
COMP/KEY WAVE(3) = ({WAVE(2)}-{WAVE(1)})/({N}-1)  ! COMPUTE NEW STEP
!WRITE/OUT {WAVE(1)},{WAVE(2)},{WAVE(3)},{N}
CREA/IMA REFIMAGE 1,{N} {WAVE(1)},{WAVE(3)}       ! CREATE REF FRAME
!
REBI/II TEMPLLOG TEMPLM REFIMAGE EXP 0.,1.,1. SPG  ! REBIN TEMPLATE
!plo TEMPLLOG
REBI/II SPECLOG  SPECM  REFIMAGE EXP 0.,1.,1. SPG  ! REBIN SPECTRUM
!plo SPECLOG
!
WRITE/OUT "computing Xcorrelation... "
XCORRELATE/IMA TEMPLLOG SPECLOG SPECX 100
!
!overplo SPECX
!
WRITE/OUT "computing velocities... "
COP/DK SPECX START/D/1/1 WAVE/D/1/1
COP/DK SPECX STEP/D/1/1 WAVE/D/3/1
COP/DK SPECX NPIX/I/1/1 N/I/1/1
!
COMP/KEY WAVE(2) = {WAVE(1)}+({N}-1)*{WAVE(3)}        ! LAST WAVE
COMP/KEY WAVE(1) = M$EXP({WAVE(1)})                   ! FIRST WAVE
COMP/KEY WAVE(2) = M$EXP({WAVE(2)})     	      ! LAST WAVE
COMP/KEY N = 2*{N}
COMP/KEY WAVE(3) = ({WAVE(2)}-{WAVE(1)})/({N}-1)      ! COMPUTE NEW STEP
!
CREA/IMA REFIMAGE 1,{N} {WAVE(1)},{WAVE(3)}           ! CREATE REF FRAME
REBI/II SPECX2 SPECX REFIMAGE LOG 0.0,1.0,1.0 SPG     ! REBIN SPECTRUM
!
COP/DK SPECX2 START/D/1/1 WAVE/D/1/1
COP/DK SPECX2 STEP/D/1/1 WAVE/D/3/1
COP/DK SPECX2 NPIX/I/1/1 N/I/1/1
!
COMP/KEY WAVE(2) = {WAVE(1)}+({N}-1)*{WAVE(3)}        ! LAST WAVE
COMP/KEY WAVE(1) = 3.E05*({WAVE(1)}-1.0) 	      ! FIRST WAVE
COMP/KEY WAVE(2) = 3.E05*({WAVE(2)}-1.0)	      ! LAST WAVE
COMP/KEY N = 2*{N}
COMP/KEY WAVE(3) = ({WAVE(2)}-{WAVE(1)})/({N}-1)      ! COMPUTE NEW STEP
! 
CREA/IMA REFIMAGE 1,{N} {WAVE(1)},{WAVE(3)}           ! CREATE REF FRAME
REBI/II {infile}Xcor SPECX2 REFIMAGE LIN 1.0,3.333E-06 SPG   ! REBIN SPECTRUM
!
COPY/DD {infile} O_TIME/d/1/6 {infile}Xcor O_TIME/d/1/6
COPY/DD {infile} DTIME/d/1/6  {infile}Xcor DTIME/d/1/6

assign/gra g,0
OVERPLOT {infile}Xcor
!
!CENTER/GAUSS gcursor ? emission
CENTER/GAUSS {infile}Xcor,&win ? emission
!
{p4},:vxcor,@{num} = {outputr(5)}
!
$rm REFIMAGE*
$rm SPEC*
!$rm {infile}Xcor.{mid$types(1:{extlen1})}
add/icat {p4}.cat  {infile}Xcor
!
goto next
!
!
finish:
read/tab {p4}
!
$rm TEMP*
$rm MASK*
dele/temp
!
! THAT'S ALL
!





