! @@ tssyn.prg
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!
! TSSYN.PRG
! A.KAUFER - LSW Heidelberg
! AK            940808  first version
!
! .PURPOSE  
!
! execute the command :
! TSSYN prefix niter column order
!  where
!      prefix  : prefix of outtables creatd by TS2PERIGRAM
!      niter   : number of iterations performed with TS2PERIGRAM
!      column  : number of column (= velocity) to use 
!      order   : order of fit to use 
!
DEFINE/PAR P1 ? C   "Enter prefix of outtables : "
DEFINE/PAR P2 ? N   "Enter number of iterations : "
DEFINE/PAR P3 ? N   "Enter number of column : "
DEFINE/PAR P4 ? N   "Enter order of fit : "
! 
define/local iii/i/1/1 0
define/local i/i/1/1 0
define/local j/i/1/1 0
define/local k/i/1/1 0
define/local niter/i/1/1 0
define/local col/i/1/1 0
define/local order/i/1/1 0
define/local intab/c/1/20 " " all
define/local outtab/c/1/20 " " all
define/local vel/d/1/1 0.
define/local pi/d/1/1 3.141592654
define/local deg/d/1/1 57.295779513
define/local c/d/1/20 0. all
!
define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

niter = {p2}
col   = {p3}
order = {p4}
outtab = "{p1}CLEAN0000"
comp/tab {outtab} :ss = 0.0
!
!loop over tables with fitted coefficients
do i = 1 {niter}
 intab = "{p1}FIT{i}"
! get frequency, phase at mean time and coeffs  -> C
 vel = {{intab},:vel,@{col}}
 c(1) = {{intab},:freq,@{col}}
 c(2) = {{intab},:phmt,@{col}}
 c(3) = {{intab},:c0001,@{col}}
 write/out "velocity  : {vel} km/s"
 write/out "frequency : {c(1)} 1/d"
 write/out "phase m.t.: {c(2)} "
 do iii = 1 {order}  
  k = 2*iii
  j = k+2
  c({j}) = {{intab},:c{k},@{col}}
  k = k+1
  j = k+2
  c({j}) = {{intab},:c{k},@{col}}
 enddo
! read/key c
!
! compute S(t)=C(0)+C(1)*sin(Ph)+C(2)*cos(Ph) with  Ph=2*pi*f*t
if {i} .eq. 1 then
  stat/tab {outtab} :l{col}
  comp/tab {outtab} :ss = :ss + {c(3)} + {outputr(3)}
endif
 do iii = 1 {order} 
  k = 2*iii+2
  comp/tab {outtab} :arg = {iii}*2*{pi}*{c(1)}*:time+{c(2)}
  comp/tab {outtab} :ss = :ss + {c({k})}*sin({deg}*:arg)
  k = k+1
  comp/tab {outtab} :ss = :ss + {c({k})}*cos({deg}*:arg)
 enddo
!
 dele/descr {outtab}.{mid$types(9:{extlen2})} HISTORY
 set/gra stype=3 color=1
 plot/tab {outtab} :time :l{col}
 set/gra stype=2 color=4
 over/tab {outtab} :time :ss
!
enddo

end:


