!
! overplot frames from a catalog, offset proportional to time
!
! use via
!
! @@ plotts cat scale vel_int cat_int
!
! with 
!  	cat       = catalog
! 	scale     = scale (units/day)
! 	vel_int   = Central wavelength, velocity interval lamc,start,end
! 	cat_int   = catalog interval first,last
!
define/para  p1 ? ? "Cat name: " 
define/para  p2 ? ? "Scale (units/day): " 
define/para  p3 6562.817,-400,400 ? "Wavelength,velocity interval lam,lo,hi :" 
define/para  p4 1,999 ? "Catalog interval first,last: " 
define/para  p5 N ?   "name for minimum table"
!
define/local offset/r/1/1 0.
define/local catal/i/1/1 0
define/local ind/i/1/1 0
define/local time0/r/1/1 0.
define/local time1/r/1/1 0.
define/local time/r/1/1 0.
define/local timey1/r/1/1 0.
define/local timey2/r/1/1 0.
define/local vint/r/1/3 {p3}
define/local int/r/1/2 {p4}
define/local span/r/1/1 0.
define/local scale/r/1/1 {p2}
define/local x0/r/1/1 0.
define/local xs/r/1/1 0.
define/local xe/r/1/1 0.
define/local ys/r/1/1 0.
define/local ye/r/1/1 0.
define/local exist/i/1/1 0
!
! find time of first and last catalog entry
ind = 0

next:
store/frame in_a {p1} 1 last
ind = {ind}+1
if {ind} .lt. {int(1)} goto next
if {ind} .ge. {int(2)} goto last
if {ind} .eq. {int(1)} then
exist = m$existd(in_a,dtime)
if {exist} .eq. 1 then
 cop/dk {in_a} dtime/d/4/1 time0/r/1/1
 else
 cop/dk {in_a} o_time/d/4/1 time0/r/1/1
 endif
endif
goto next
last:
exist = m$existd(in_a,dtime)
if {exist} .eq. 1 then
cop/dk {in_a} dtime/d/4/1 time1/r/1/1
else
cop/dk {in_a} o_time/d/4/1 time1/r/1/1
endif
span = time1 - time0
set/form F8.2
write/out "Time interval: MJD {time0}-{time1}"
set/form
if "{p5}" .ne. "N" then
 crea/tab {p5} 3 {ind} 
 crea/col {p5} :jd24 F12.4
 crea/col {p5} :vmin F7.2
 crea/col {p5} :Imin F7.3
endif

!
catal =  0
ind = 0
next1:
store/frame in_a {p1} 1 finish
ind = {ind}+1
if {ind} .lt. {int(1)} goto next1
if {ind} .gt. {int(2)} goto finish
if {ind} .eq. {int(1)} then
 timey1 = {time0}-1./{scale}
 timey2 = {time1}+1./{scale}

! HD96919 ls94
! timey1 = 49460
! timey2 = 49490
! bOri lsw93
! timey2 = 49300
! timey1 = 49260
! HD96919 ls96
! timey2 = 50200
! timey1 = 50100
! HR1040 lsw92
 timey1 = 48620
 timey2 = 48730

 offset = {time0}-1./{scale}
 set/gra xa={vint(2)},{vint(3)} ya={timey1},{timey2} 
 plo/axes ? ? ? "Velocity [km/s]" "JD-2400000.5"
 vextract/spec {in_a} &xxx {p3}
!
if "{p5}" .ne. "N" then
 copy/dk &xxx start/d/1/1 start/d/1/1
 copy/dk &xxx step/d/1/1 step/d/1/1
 stat/ima &xxx
 {p5},:jd24,{ind} = time0
 {p5},:vmin,{ind} = start + outputi(2)*step
 {p5},:Imin,{ind} = outputr(1)
endif
!
 comp &xxx = &xxx/{scale}
 over &xxx ? ? {offset}
else
exist = m$existd(in_a,dtime)
if {exist} .eq.  1 then
 cop/dk {in_a} dtime/d/4/1 time/r/1/1
 else
 cop/dk {in_a} o_time/d/4/1 time/r/1/1
endif
 vextract/spec {in_a} &xxx {p3}
!
if "{p5}" .ne. "N" then
 copy/dk &xxx start/d/1/1 start/d/1/1
 copy/dk &xxx step/d/1/1 step/d/1/1
 stat/ima &xxx
 {p5},:jd24,{ind} = time
 {p5},:vmin,{ind} = start + outputi(2)*step
 {p5},:Imin,{ind} = outputr(1)
endif
!
 comp &xxx = &xxx/{scale}
 offset = {time}-1/{scale}
 over &xxx ? ? {offset}
endif
goto next1
!
finish:
!
write/out "Mark position of scale with cursor:"
get/gcurs
x0 = outputr(1)
xs = x0-5.
xe = x0+5.
ys = outputr(2)+0.1/scale/2.
ye = outputr(2)-0.1/scale/2.
over/line 1 {x0},{ys} {x0},{ye}
over/line 1 {xs},{ys} {xe},{ys}
over/line 1 {xs},{ye} {xe},{ye}
xe = x0+15
label/gra "0.10" {xe},{outputr(2)} 0 0.8 1

exit:
dele/temp
