! @(#)xbalmerplot.prg	6.1.1.1 (ESO-IPG) 12/03/93 16:00 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure xbalmerplot.prg 
! A. Kaufer	931203
!
! use via xbalmerplot inframe high vrange yrange
!
!  inframe   :  name of spectrum
!  high      :  number of highes balmer line
!  vrange    :  velocity range vstart,vstop  
!  yrange    :  y range  ystart,ystop
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/parameter P1 ? IMA   " Enter image name : "
define/parameter P2 1,4 N   " Enter number of lowest,highest Balmer line: "
define/parameter P3 -500,500 N " Enter velocity range : "
define/parameter P4 ? N   " Enter y offset : "
!
define/local i/i/1/1 1
define/local yoff/r/1/1 0
define/local lyoff/r/1/1 0
define/local xoff/r/1/1 0
define/local a/i/1/1 0
define/local b/i/1/1 0
define/local lim/r/1/2 0,0
define/local vlim/r/1/2 {P3}
define/local ylim/r/1/2 0,0
define/local yoffset/r/1/1 {p4}
define/local lam/d/1/40 0.0 all
define/local nam/c/1/80 " " all
define/local balm/i/1/2 {p2}
!
define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

copy/tab  TSDATA:balmer &balmer
!
crea/ima &r 1,2000 -1000.,1.
!
xoff = vlim(1)+0.1*({vlim(2)}-{vlim(1)})
ylim(1) = 0.
ylim(2) = ylim(1)+1+(balm(2)-balm(1)+1)*{yoffset}
yoff = ylim(2)-1
ylim(2) = ylim(2)+.25*({ylim(2)}-{ylim(1)})
ylim(2) = {P5}
set/gra pmode=1 font=1
set/gra xa={P3} ya={ylim(1)},{ylim(2)}
plot/axes ? ? ? "Velocity [km/s]" "rel. Flux"
!
set/form F8.3
do i = {balm(1)} {balm(2)} 1
 lam({i}) = {&balmer,:lambda,{i}}
 nam      = "{&balmer,:ident,{i}}"
 write/out {nam} at {lam({i})} A
 lim(1) = {lam({i})}-100.
 lim(2) = {lam({i})}+100.
if i .eq. 1 then
! extra/ima &a = ../red/{P1}[{lim(1)}:{lim(2)}]
  vextra/spec  ../red/{P1} &a {lam({i})},{P3}
else
! extra/ima &a = ../blue/{P1}[{lim(1)}:{lim(2)}]
  vextra/spec ../blue/{P1} &a {lam({i})},{P3}
endif
! copy/dk &a start/d/1/1 outputd/d/1/1
! outputd(2) = ({outputd(1)}-{lam({i})})/{lam({i})}*3.d5
! write/desc &a start/d/1/1 {outputd(2)}
! copy/dk &a step/d/1/1 outputd/d/1/1
! outputd(2) = {outputd(1)}/{lam({i})}*3.d5
! write/desc &a step/d/1/1 {outputd(2)}
! copy/ii &a {P1}H{i}
! write/out " Extracted image in {P1}H{i}.{mid$types(1:{extlen1})} " 
 yoff = yoff - yoffset
 overplot &a ? ? {yoff}
 lyoff = yoff - 0.5*yoffset+1
 label/graphic "{nam}" {xoff},{lyoff} ? 1.3 1
enddo
!
xoff = vlim(1)+0.1*({vlim(2)}-{vlim(1)})
yoff = ylim(2)-0.07*({ylim(2)}-{ylim(1)})
!label/graphic "Balmer line profiles " {xoff},{yoff} ? 1 1
yoff = ylim(2)-0.12*({ylim(2)}-{ylim(1)})
label/graphic {P6} {xoff},{yoff} ? 1.5 1
!
FINISH:
!
dele/temp
set/gra
set/form
!
! THAT'S ALL
!
