! @(#)xbalmerprogr.prg	6.1.1.1 (ESO-IPG) 12/03/93 16:00 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure xbalmerprogr.prg 
! A. Kaufer	940405
!
! use via xbalmerprogr catalog
!
!  inframe   :  catalog of spectra
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/parameter P1 ? CAT " Enter catalog name : "
define/parameter P2 1,4 N " Enter number of lowest and highest Balmer line: "
define/parameter P3 25  N " Enter center halfwidth in velocities: "
define/parameter P4 ?   C " Plot over wavelength or quantum number [w/n] ?"
define/parameter P5 0   N " Enter velocitiy Offset for centering :"
!
define/local i/i/1/1 1
define/local j/i/1/1 1
define/local yoff/r/1/1 0
define/local xoff/r/1/1 0
define/local ncol/i/1/1 5
define/local xmin/r/1/1 0.0
define/local xmax/r/1/1 0.0
define/local ymin/r/1/1 0.0
define/local ymax/r/1/1 0.0
define/local lim/r/1/2 0,0
define/local x/r/1/2 0,0
define/local y/r/1/2 0,0
define/local lam/d/1/40 0.0 all
define/local dlam/d/1/1 0.0
define/local olam/d/1/1 0.0
define/local nam/c/1/80 " " all
define/local balm/i/1/2 0,0
define/local m/i/1/2 0,0
define/local ptype/c/1/1 "{p4}"

define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8
!
write/key balm/i/1/2 {p2}
copy/tab  TSDATA:balmer &balmer
!
! measure radial velocities
set/form F8.3
do i = {balm(1)} {balm(2)} 1
 lam({i}) = {&balmer,:lambda,{i}}
 nam      = "{&balmer,:ident,{i}}"
 dlam     = lam({i})*(1.+{p3}/3.e5)-lam({i})
 dlam     = m$abs(dlam)
 olam     = lam({i})*(1.+{p5}/3.e5)-lam({i})
 write/out "{nam} at {lam({i})} A with dlam = {dlam} and offset = {olam}"
 lim(1) = lam({i})-dlam+olam
 lim(2) = lam({i})+dlam+olam
 center/ts {p1} {nam} GAUSS {lim(1)},{lim(2)},{lam({i})} 
enddo
!
! make table
ncol = balm(2)-balm(1)+3
nam      = "{&balmer,:ident,{balm(1)}}"
copy/dk {nam}.{mid$types(9:{extlen2})} tblcontr/i/4/4 nrow/i/1/1
crea/tab balmerprogr {ncol} 200
copy/tt {nam} :jd24 balmerprogr :jd24
do i = {balm(1)} {balm(2)} 1
 nam = "{&balmer,:ident,{i}}"
 write/out {nam} at {lam({i})} A
 copy/tt {nam} :vrad balmerprogr :{nam}
 dele/tab {nam} NO
enddo
!
! plot it
set/gra pmode=1
nam = "{&balmer,:ident,{balm(1)}}"
stat/tab balmerprogr {nam}
ymin = {outputr(1)}-10
nam = "{&balmer,:ident,{balm(2)}}"
stat/tab balmerprogr {nam}
ymax =  {outputr(2)}+10
if "{ptype}" .eq. "w" then
 xmin = lam(balm(1))+0.1*(lam(balm(1))-lam(balm(2)))
 xmax = lam(balm(2))-0.1*(lam(balm(1))-lam(balm(2)))
 set/gra xa={xmin},{xmax} ya={ymin},{ymax}
 plot/axes ? ? ? "Wavelength [\AA ]" "Velocity [km/s]" 
else
 m(1) = ({&balmer,:m,{balm(1)}})
 m(2) = ({&balmer,:m,{balm(2)}})
 xmin = m(1)+0.1*(m(1)-m(2))
 xmax = m(2)-0.1*(m(1)-m(2))
 set/gra xa={xmin},{xmax} ya={ymin},{ymax}
 plot/axes ? ? ? "Quantum number of upper level" "Velocity [km/s]" 
endif
do j = 1 {nrow} 1
 write/out "JD24{balmerprogr,:jd24,@{j}}"
 do i = {balm(1)} {balm(2)}
  nam = "{&balmer,:ident,{i}}"
  if "{ptype}" .eq. "w" then
   x(1) = {lam({i})}  
  else
   x(1) = ({&balmer,:m,{i}})
  endif
  y(1) = {balmerprogr,:{nam},@{j}}
  over/sym 1 {x(1)},{y(1)}
  if {i} .gt. {balm(1)} then
   over/line 1 {x(1)},{y(1)} {x(2)},{y(2)}
  endif
  x(2) = x(1)
  y(2) = y(1)
 enddo
enddo

xoff = xmin+0.1*(xmax-xmin)
yoff = ymax-0.1*(ymax-ymin)
label/graphic "Balmer Progression " {xoff},{yoff} ? 1 1
yoff = ymax-0.15*(ymax-ymin)
label/graphic "Catalog : {P1}" {xoff},{yoff} ? 0.7 1
do i = {balm(1)} {balm(2)}
 nam = "{&balmer,:ident,{i}}"
 if "{ptype}" .eq. "w" then
  xoff = {lam({i})} 
 else
  xoff = ({&balmer,:m,{i}})
 endif
 yoff = ymin+0.1*(ymax-ymin)
 label/graphic "{nam}" {xoff},{yoff} ? 0.7 
enddo

!
FINISH:
!
dele/temp
set/gra
set/form
!
! THAT'S ALL
!
