! @@ tsdisplay2.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  xperdisplay.prg  
! A. Kaufer	940425
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ? C "Enter image to display: "
define/par p2 ? C "Enter name of Line : "
define/par p3 2,1 N "Enter x,y scale for load/ima : "
!
define/local xl1/c/1/20  "Velocity [km/s]"  
define/local yl1/c/1/20  "Frequency [1/d]"
define/local xl2/c/1/20  "Wavelength [\AA ]"  
define/local yl2/c/1/40  "(average power)\{\times \}10\{\!u-3\} "  
!
define/local ii/i/1/1 512
define/local xx/i/1/1 512
define/local yy/i/1/1 512
define/local xs/i/1/1 1
define/local ys/i/1/1 1
define/local zz/i/1/1 50
define/local scale/r/1/2 0 all
define/local xend/d/1/2 0.0 all
define/local ystart/d/1/2 0.0 all
define/local ystep/d/1/2 0.0 all
define/local ynpix/i/1/2 0 all
define/local xxstart/d/1/2 0.0 all
define/local xxstep/d/1/2 0.0 all
define/local x1/d/1/1 0.0
define/local x2/d/1/1 0.0
define/local y1/d/1/1 0.0
define/local y2/d/1/1 0.0
!
crea/gra 
plo {p1}
!
copy/dk {p1} start/d/1/2 xstart/d/1/2
copy/dk {p1} step/d/1/2 xstep/d/1/2
copy/dk {p1} npix/i/1/2 xnpix/i/1/2
xend(1) = xstart(1)+xnpix(1)*xstep(1)
xend(2) = xstart(2)+xnpix(2)*xstep(2)
!
xx = xnpix(1)*1.75 
yy = xnpix(2)*2.25 
!
ystart(1) = xstart(1)-(xx/2-xnpix(1)/2)*xstep(1) 
ystart(2) = xstart(2)-(yy/2-xnpix(2)*2/3)*xstep(2) 
xx = xx+zz
!
dele/disp 0
write/key scale/r/1/2 {p3}
if {scale(1)} .lt. 0 then
 scale(1) = 1/M$ABS(scale(1))
endif
if {scale(2)} .lt. 0 then
 scale(2) = 1/M$ABS(scale(2))
endif
xs = xx*scale(1)
ys = yy*scale(2)
crea/disp 0 {xs},{ys},100,500
!
crea/ima &x 2,{xx},{yy} {ystart(1)},{ystart(2)},{xstep(1)},{xstep(2)} POLY 99,0
copy/dd {p1} LHCUTS/R/1/4 &x LHCUTS/R/1/4
write/descr &x IDENT/C/1/72 {p1}
copy/dk &x lhcuts/r/1/1 low/r/1/1
copy/dk &x lhcuts/r/2/1 high/r/1/1
copy/dk &x lhcuts/r/3/1 min/r/1/1
copy/dk &x lhcuts/r/4/1 max/r/1/1
!
insert/ima {p1} &x
load &x sc={p3}
!
! load time series image
clear/chan over
assign/gra D,0
set/gra color=1 font=0 tsize=1.2
x1 = xstart(1)-1*xstep(1)
y1 = xstart(2)-1*xstep(2)
x2 = xend(1)               !-1*xstep(1)
y2 = xend(2)               !-1*xstep(2)
plot/axes [{x1},{y1}:{x2},{y2}]  "{xl1}" "{yl1}"
! label plot
y1 = y1-(y1-ystart(2))/xstep(2)*2/3*xstep(2)
label/gra "{p1} created from {p2}" {x1},{y1} ? 1 1
!
copy/key xstart/d/1/2 xxstart/d/1/2
copy/key xstep/d/1/2 xxstep/d/1/2
!
! compute average powerspectrum
!
average/col &out = {p1}
copy/it &out &out :freq
name/col &out :LAB002 :power
comp/tab &out :power = :power*1000
!
stat/tab &out :power
min = outputr(1)
max = outputr(2)
min = min-outputr(3)
max = max+outputr(3)
! 
! create new coordsystem for power spectrum overplot
ii = xnpix(1)*1.75
zz = zz-0.2*zz
xstep(1) = (max-min)/zz
xstart(1) = min-(ii-0.25*zz)*xstep(1)
!
write/descr &x start/d/1/1 {xstart(1)}
write/descr &x step/d/1/1  {xstep(1)}
!
! overplot average powerspectrum in seperate box
set/gra color=1 font=0 tsize=1.2 bin=on stype=0 ltype=1
!
x1 = min-2*xstep(1)
y1 = xstart(2)-1*xstep(2)
x2 = max+1*xstep(1)
y2 = xend(2)
over/axes [{x1},{y1}:{x2},{y2}] "{yl2}" " "
over/tab &out :power :freq

!
copy/key xxstart/d/1/2 xstart/d/1/2
copy/key xxstep/d/1/2 xstep/d/1/2
write/descr &x start/d/1/1 {xstart(1)}
write/descr &x step/d/1/1  {xstep(1)}
!
! compute average power over wavelength
!
average/row &out = {p1}
comp/ima &out = &out*1000
!
stat/ima &out
min = outputr(1)
max = outputr(2)
min = min-outputr(3)
max = max+outputr(3)
! 
! create new coordsystem for power spectrum overplot
!ii = (xend(2)-ystart(2))/xstep(2)+yy*0.1
ii = (xend(2)-ystart(2))/xstep(2)
zz = (yy-ii)-0.5*(yy-ii)
xstep(2) = (max-min)/zz
ystart(2) = min-(ii+0.35*(yy-ii))*xstep(2)
write/descr &x start/d/2/1 {ystart(2)}
write/descr &x step/d/2/1  {xstep(2)}

!
! go back to wavelength domain in x
copy/dk {p1} lamc/d/1/1 lamc/d/1/1
xstart(1) = lamc*(1+xstart(1)/3e5)
ystart(1) = lamc*(1+ystart(1)/3e5)
xend(1) = lamc*(1+xend(1)/3e5)
xstep(1) = (xend(1)-xstart(1))/xnpix(1)
write/descr &x start/d/1/1 {ystart(1)}
write/descr &x step/d/1/1  {xstep(1)}
!

! overplot average power over wavelength in seperate box
set/gra color=1 font=0 tsize=1.2 bin=on
!
write/descr &out start/d/1/1 {xstart(1)}
write/descr &out step/d/1/1  {xstep(1)}
!
x1 = xstart(1)-1*xstep(1)
y1 = min-2*xstep(2)
x2 = xend(1)
!y2 = max+2*xstep(2)
y2 = max+1*xstep(2)
load &x
assign/gra D,0
over/axes [{x1},{y1}:{x2},{y2}] "{xl2}" "{yl2}"
over &out
!
set/gra default
assign/gra G
dele/temp
!$rm *.plt





