!
! MIDAS procedure xplot.prg 
! A. Kaufer	931028
!
! use via xplot intable label [device]
!
!  intable  table with output from xcenter.prg
!  label    label at top of plot
!  device   should be a lasera with portrait option
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  
define/par p1 ?  TAB      "Enter table: "
define/par p2 ?  C        "Enter label: "
define/par p3 lasera.p C "Enter device: "
!
define/local jd/r/1/2 0. all
define/local vrad/r/1/2 0. all
define/local int/r/1/2 0. all
define/local fwhm/r/1/2 0. all
define/local wlam/r/1/2 0. all
define/local chisqr/r/1/2 0. all
!
set/gra
!set/gra stype=0 ltype=1
!
stat/table {p1} :jd24
jd(1) =  outputr(1)-0.03*(outputr(2)-outputr(1))
jd(2) =  outputr(2)+0.03*(outputr(2)-outputr(1))
write/out {jd(1)} {jd(2)}
!
stat/table {p1} :vrad
vrad(1) =  outputr(1)-0.035*(outputr(2)-outputr(1))
vrad(2) =  outputr(2)+0.035*(outputr(2)-outputr(1))
write/out {vrad(1)} {vrad(2)}
!
stat/table {p1} :int
int(1) =  outputr(1)-0.035*(outputr(2)-outputr(1))
int(2) =  outputr(2)+0.035*(outputr(2)-outputr(1))
write/out {int(1)} {int(2)}
!
stat/table {p1} :fwhm
fwhm(1) =  outputr(1)-0.035*(outputr(2)-outputr(1))
fwhm(2) =  outputr(2)+0.035*(outputr(2)-outputr(1))
write/out {fwhm(1)} {fwhm(2)}
!
stat/table {p1} :wlam
wlam(1) =  outputr(1)-0.035*(outputr(2)-outputr(1))
wlam(2) =  outputr(2)+0.035*(outputr(2)-outputr(1))
write/out {wlam(1)} {wlam(2)}
!
stat/table {p1} :chisqr
chisqr(1) =  outputr(1)-0.035*(outputr(2)-outputr(1))
chisqr(2) =  outputr(2)+0.035*(outputr(2)-outputr(1))
write/out {chisqr(1)} {chisqr(2)}
!
assign/graphics {p3} nospool
!
plo/axes  {jd(1)},{jd(2)} {vrad(1)},{vrad(2)} -160,-42,20,215 ? "v\{\_rad\} [km/s]"
!
label/gra "{p2}" 0,47,mm 0 1.3 1
label/gra "table: {p1}" 160,47,mm 0 1.3 2
!
over/tab {p1} :jd24 :vrad
over/err {p1} :jd24 :vrad :dvrad
!
over/axes  {jd(1)},{jd(2)} {wlam(1)},{wlam(2)} -160,-42,20,165 ? "W\{\_\lambda \}[m\AA ]"
over/tab {p1} :jd24 :wlam
over/err {p1} :jd24 :wlam :dwlam
!
over/axes  {jd(1)},{jd(2)} {int(1)},{int(2)} -160,-42,20,115 ? "rel.int"
over/tab {p1} :jd24 :int
over/err {p1} :jd24 :int :dint
!
over/axes  {jd(1)},{jd(2)} {fwhm(1)},{fwhm(2)} -160,-42,20,65 ? "FWHM [\AA ]"
over/tab {p1} :jd24 :fwhm
over/err {p1} :jd24 :fwhm :dfwhm
!
over/axes  {jd(1)},{jd(2)} {chisqr(1)},{chisqr(2)} -160,-42,20,15 "JD-2400000.5" "\Chi \{\!u2\}"
over/tab {p1} :jd24 :chisqr
!
copy/graph {p3}
assign/graphics 
!
return


