! @@ tsdisplay2.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  xtsdisplay.prg  
! A. Kaufer	940425
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ? C   "Enter image to display: "
define/par p2 ? C   "Enter catalog for overplot : "
define/par p3 2,1 N "Enter x,y scale for load/ima : "
define/par p4 0,0 N "Enter min,max values for overplot: "
define/par p5 w C   "overplot in velocities or wavelengths [v/w]: "
!
define/local xl1/c/1/20  "Velocity [km/s]"  
define/local yl1/c/1/20  " " all
copy/dk {p1} cunit/c/33/16  yl1/c/1/20
define/local xl2/c/1/20  "Wavelength [\AA ]"  
define/local yl2/c/1/20  "rel.flux"  
!
define/local ii/i/1/1 512
define/local xx/i/1/1 512
define/local yy/i/1/1 512
define/local xs/i/1/1 1
define/local ys/i/1/1 1
define/local zz/i/1/1 50
define/local xg/i/1/1 10
define/local yg/i/1/1 0
define/local scale/r/1/2 0 all
define/local xend/d/1/2 0.0 all
define/local ystart/d/1/2 0.0 all
define/local ystep/d/1/2 0.0 all
define/local ynpix/i/1/2 0 all
define/local x1/d/1/1 0.0
define/local x2/d/1/1 0.0
define/local y1/d/1/1 0.0
define/local y2/d/1/1 0.0
define/local minmax/r/1/2 {p4}
!
crea/gra 
set/gra
plo {p1}
!
copy/dk {p1} start/d/1/2 xstart/d/1/2
copy/dk {p1} step/d/1/2 xstep/d/1/2
copy/dk {p1} npix/i/1/2 xnpix/i/1/2
xend(1) = xstart(1)+xnpix(1)*xstep(1)
xend(2) = xstart(2)+xnpix(2)*xstep(2)

xx = xnpix(1)*1.75 
yy = xnpix(2)*2.25 

ystart(1) = xstart(1)-(xx/2-xnpix(1)/2)*xstep(1) 
ystart(2) = xstart(2)-(yy/2-xnpix(2)*2/3)*xstep(2) 

dele/disp 0
write/key scale/r/1/2 {p3}
if {scale(1)} .lt. 0 then
 scale(1) = 1/M$ABS(scale(1))
endif
if {scale(2)} .lt. 0 then
 scale(2) = 1/M$ABS(scale(2))
endif
xs = xx*scale(1)
ys = yy*scale(2)
crea/disp 0 {xs},{ys},100,500

crea/ima &x 2,{xx},{yy} {ystart(1)},{ystart(2)},{xstep(1)},{xstep(2)} POLY 9e9,0
copy/dd {p1} LHCUTS/R/1/4 &x LHCUTS/R/1/4
write/descr &x IDENT/C/1/72 {p1}
copy/dk &x lhcuts/r/1/1 low/r/1/1
copy/dk &x lhcuts/r/2/1 high/r/1/1
if {minmax(1)} .eq. {minmax(2)} then
 copy/dk &x lhcuts/r/3/1 min/r/1/1
 copy/dk &x lhcuts/r/4/1 max/r/1/1
else
 write/key min/r/1/1 {minmax(1)}
 write/key max/r/1/1 {minmax(2)}
endif

!max = 1.65
!min = 0.82

insert/ima {p1} &x
load &x sc={p3}

! load time series image
clear/chan over
assign/gra d,0
set/gra color=1 font=0 tsize=1.6
x1 = xstart(1)-1*xstep(1)
y1 = xstart(2)-1*xstep(2)
x2 = xend(1)               !-1*xstep(1)
y2 = xend(2)               !-1*xstep(2)
plot/axes [{x1},{y1}:{x2},{y2}]  "{xl1}" "{yl1}"
! label plot
y1 = y1-(y1-ystart(2))/xstep(2)*2/3*xstep(2)
label/gra "{p1} created from {p2}" {x1},{y1} ? 1 1

! indicate where spectra were measured
!load/tab {p1} :x :t :ident -1 8 1
!
!
define/local n/i/1/1 0
define/local label/i/1/1 0
define/local nrow/i/1/1 0
!
copy/dk {p1}.tfits tblcontr/i/4/4 nrow/i/1/1
set/format I2
do n = 1 {nrow} 
 x1 = {{p1},:x,@{n}}
 y1 = {{p1},:t,@{n}}
 n = n+1
 x2 = {{p1},:x,@{n}}
 y2 = {{p1},:t,@{n}}
 over/line 1 {x1},{y1} {x2},{y2}
 label = {{p1},:ident,@{n}}
 x2 = x2-2*(x2-x1) 
! label/gra "{label}" {x2},{y2} ? 0.8 1
enddo
set/format
! 
! create new coordsystem for spectra overplot
!ii = (xend(2)-ystart(2))/xstep(2)+yy*0.1
ii = (xend(2)-ystart(2))/xstep(2)
zz = (yy-ii)-0.5*(yy-ii)
xstep(2) = (max-min)/zz
ystart(2) = min-(ii+0.35*(yy-ii))*xstep(2)
write/descr &x start/d/2/1 {ystart(2)}
write/descr &x step/d/2/1  {xstep(2)}
!
! insert gray scale ramp
x1 = xend(1)+5*xstep(1)
y1 = low
xg = m$nint(0.05*xx)
yg = (high-low)/xstep(2)+1
crea/ima &r 2,{xg},{yg} {x1},{y1},{xstep(1)},{xstep(2)} POLY 0,0,1
insert/ima &r &x
!
if "{p5}" .eq. "w" then
!
! go back to wavelength domain in x
 copy/dk {p1} lamc/d/1/1 lamc/d/1/1
 xstart(1) = lamc*(1+xstart(1)/3e5)
 ystart(1) = lamc*(1+ystart(1)/3e5)
 xend(1) = lamc*(1+xend(1)/3e5)
 xstep(1) = (xend(1)-xstart(1))/xnpix(1)
 write/descr &x start/d/1/1 {ystart(1)}
 write/descr &x step/d/1/1  {xstep(1)}
else  
 xl2 = " "
endif
!
! overplot spectra in seperate box
!
set/gra color=1 font=0 tsize=1.6 bin=on 
x1 = xstart(1)-1*xstep(1)
y1 = min-2*xstep(2)
x2 = xend(1)
!y2 = max+2*xstep(2)
y2 = max+1*xstep(2)
load &x
assign/gra D,0
over/axes [{x1},{y1}:{x2},{y2}] "{xl2}" "{yl2}"
x2 = xend(1)+(4+10)*xstep(1)
over/line 2 {x1},{low} {x2},{low}
over/line 2 {x1},{high} {x2},{high}
!
copy/dk {p1} CATINTV/i/1/2 intv/i/1/2
@@ TSPROC:xovercat {p2} {intv(1)},{intv(2)}
!
set/gra default
assign/gra G
!
dele/temp
$rm *.plt




