!   ***************
!   *   XWAVEPG   *
!   ***************
!
!   Linienfit mit 1 Polynom und 1 Gausskurve:
!       - pol  : Kontinuum
!       - gau  : Abs.-Komponente
!       - a    : Linien-Tiefe
!       - b    : Linien-Position
!       - c    : Linien-Breite
!       - err  : Fehler der jeweiligen Groesse
!
!     @@ xwavepg catalogue   table  start end  fit-file lambda(Labor)
! ex: @@ xwavepg HD92207.cat Si6347 6342  6350 Si6347   6347.109
!
!                                         ToM. 11.5.93
!
!
define/local catal/i/1/1 0
define/local ind/i/1/1 0
define/local num/i/1/1 0
define/local infile/c/1/20 " " all
define/local wave/r/1/8 0. all
define/local jd24/r/1/1 0. 
define/local fitparam/r/1/11 0.  all
define/local fiterror/r/1/11 0.  all
!
define/local extlen1/i/1/1 0
define/local extlen2/i/1/1 0

extlen1 = m$index(mid$types(1:8)," ")-1
extlen2 = m$index(mid$types(9:16)," ")+8

goto start
!
start:
!
crea/tab {p2} 12 110
crea/col {p2} :file " " A20 C*20
crea/col {p2} :jd24 " " R*8 
crea/col {p2} :gau_a " " R*8 
crea/col {p2} :dgau_a " " R*8 
crea/col {p2} :gau_b " " R*8 
crea/col {p2} :dgau_b " " R*8 
crea/col {p2} :gau_c " " R*8 
crea/col {p2} :dgau_c " " R*8 
crea/col {p2} :vrad " " R*8 
crea/col {p2} :dvrad " " R*8 
crea/col {p2} :wlam " " R*8 
crea/col {p2} :dwlam " " R*8 
!
wave(1)   =  {p3} ! start
wave(2)   =  {p4} ! end
wave(7)   = 0.12  ! step
!
set/gra pmode=1
!
next:
store/frame in_a {p1} 1 finish
dele/temp no
num = num+1
write/out {in_a}
!
ind = m$index(in_a,".{mid$types(1:{extlen1})}")-1
write/key infile/c/1/20 " " all
write/key infile/c/1/{ind} {in_a}/c/1/{ind}
{p2},:file,@{num} = {infile}
cop/dk {infile} dtime/d/4/1 jd24/r/1/1
write/out {jd24}
{p2},:jd24,@{num} = {jd24}
!
extra/ima &a = {infile}[{wave(1)}:{wave(2)}]   
fit/ima 50,0.001,0.2 middumma {p5}
!
set/gra xa={wave(1)},{wave(2)} ya=0,1.5  
comp/fit middummb = {p5}(middumma)		
plo &a 									
set/gra colour=4
over &b									
set/gra colour
!comp &c = &a-&b							
!set/gra ya=-0.1,0.1 						
!plot &c								
cop/dk {p5}.fit fitparam/d/1/11 fitparam/r/1/11
cop/dk {p5}.fit fiterror/d/1/11 fiterror/r/1/11
!
{p2},:gau_a,@{num} = {fitparam(3)}
{p2},:dgau_a,@{num} = {fiterror(3)}
{p2},:gau_b,@{num} = {fitparam(4)}
{p2},:dgau_b,@{num} = {fiterror(4)}
{p2},:gau_c,@{num} = {fitparam(5)}
{p2},:dgau_c,@{num} = {fiterror(5)}
!
goto next
finish:
!
comp/tab {p2} :vrad = (:gau_b - {p6})*3e5/{p6}
comp/tab {p2} :dvrad = 3e5/{p6}*:dgau_b
!
comp/tab {p2} :wlam = :gau_a*:gau_c 
comp/tab {p2} :dwlam = SQRT((:dgau_a**2)+(:dgau_c**2))
!
name/colum {p2} :gau_b "\lambda "
name/colum {p2} :gau_a "\rel. linedepth"
name/colum {p2} :jd24  "days"
name/colum {p2} :vrad  "km/s"
name/colum {p2} :wlam  "Angstrom"
!
exit:

