C  @(#)tsaclean.for	
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT (c)  1994     ESO, Warsaw Observatory and Landessternwarte HD
C.IDENT     tsaclean.for
C.AUTHOR    Alex Schwarzenberg-Czerny, ESO and Warsaw Observatory 
C.          Andreas Kaufer, Landessternwarte Heidelberg
C.KEYWORD   MIDAS, time series, PERIGR/TS
C.LANGUAGE  FORTRAN 77
C.PURPOSE   CLEAN - like algorithm
C.VERSION   0.0               October 1994
C.RETURNS   a lot
C.ENVIRON   TSA context
C
C Versions
C  1994/10/27  transcription of parts of TS2PERIGRAM.PRG to Fortran 
C
C-----------------------------------------------------------------------------
C
      PROGRAM TSACLEAN
C
      IMPLICIT NONE
      INTEGER  ISTAT,STATUS
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      CHARACTER*1  ACTION,ACTION2
      CHARACTER*60 INAME                !  NAME OF INPUT TABLE
      CHARACTER*60 ONAME                !  NAME OF OUTPUT TABLE
      CHARACTER*60 RESNAME              !  NAME OF OUTPUT IMAGE
      CHARACTER*60 POWNAME              !  NAME OF OUTPUT IMAGE
C
      REAL*8       START(2)            
      REAL*8       STEP(2)             
      INTEGER      NSTEPS(2)           
      INTEGER      NAXIS,IFLAG,IBUF(5)
      INTEGER      PPOW,IPOW,PRES,IRES
      CHARACTER*60 IDENT
      CHARACTER*60 CUNIT
C
      REAL*8       VSTART,VSTEP
      INTEGER      VNSTEP
      REAL*8       STARTTSA,STEPTSA
      INTEGER      NSTEPTSA,ORDERTSA
C
      INTEGER      FITITER,MAXORDER
      PARAMETER   (MAXORDER=20)
      REAL         PREFREQ,LOS
      REAL*8       BANDC,BANDW,MAXPOW,MAX
      REAL*8       OUT(4),COEF(MAXORDER+3)
C
      LOGICAL      SCARGL, CLEAN, PREWHIT
      INTEGER      I,III,POS,IACTS,KUN,KNUL
      INTEGER      TID,NCOL,ICOL,NROW,IROW,ISOR
      INTEGER      ITIME,IVAL,IL 
      INTEGER      TIDO,NCOLO,NROWO,ISORO,ICOLO,IROWO
      INTEGER      IVEL,IFREQ,IDFREQ,IPHMT,IDPHMT,IC(MAXORDER),IMAXPOW
      INTEGER      LFIELD,TTYP,VTYP
      INTEGER      PTIME,PVAL,PL
C
      CHARACTER*10 FORM
      CHARACTER*5  CLAB
      CHARACTER*80 TEXT
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Init MIDAS
C     
      CALL STSPRO('tsaclean')
C
C   Set filenames 
C
      INAME =   'middummtab'
      ONAME =   'middummtabf'
      RESNAME = 'middummres'
      POWNAME = 'middummpow'
C
C   Map input table INAME
C
      CALL TBTOPN (INAME,F_IO_MODE,TID,ISTAT)
      CALL TBIGET (TID,NCOL,NROW,ISOR,ICOL,IROW,ISTAT)
      CALL TBLSER (TID,'TIME',ITIME,ISTAT)
      IF (ITIME.LT.0) THEN
        CALL STETER(3,'Column :TIME not found')
      ENDIF
      CALL TBLSER (TID,'VALUE',IVAL,ISTAT)
      IF (IVAL.LT.0) THEN
        CALL STETER(4,'Column :VALUE not found')
      ENDIF
      CALL TBFGET (TID,ITIME,FORM,LFIELD,TTYP,ISTAT)
      CALL TBFGET (TID,IVAL, FORM,LFIELD,VTYP,ISTAT)
      CALL TBDGET (TID,ISTORE,ISTAT)
      IF (ISTORE.NE.F_TRANS) THEN
        TEXT='Input table '//INAME//' stored not transposed'
        CALL STETER(2,TEXT)
      ENDIF
      IF (TTYP.NE.D_R8_FORMAT.OR.VTYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,
     $    'Data column(s) must be of DOUBLE PRECISION type')
      ENDIF
      CALL TBCMAP (TID,ITIME,PTIME,ISTAT)
      CALL TBCMAP (TID,IVAL, PVAL, ISTAT)
C
C   Map output frames RESNAME, POWNAME
C
      IFLAG=2
      CALL STFINF (RESNAME,IFLAG,IBUF,ISTAT)
      ITYP=IBUF(2)
      IF (ITYP.NE.D_R8_FORMAT) THEN
        CALL STETER(1,'Result frames must be in DOUBLE PRECISION')
      ENDIF
      CALL STIGET(RESNAME,D_R8_FORMAT,F_IO_MODE,F_IMA_TYPE,2,NAXIS,
     $            NSTEPS,START,STEP,IDENT,CUNIT,PRES,IRES,ISTAT)
C
      CALL STIGET(POWNAME,D_R8_FORMAT,F_IO_MODE,F_IMA_TYPE,2,NAXIS,
     $            NSTEPS,START,STEP,IDENT,CUNIT,PPOW,IPOW,ISTAT)
C
C   Get/set parameters
C
      CALL STKRDC ('CLEAN',1,1,1,IACTS,ACTION,KUN,KNUL,ISTAT)
      CLEAN =  ACTION.EQ.'Y'.OR.ACTION.EQ.'I'
C
      CALL STKRDC ('PREWHIT',1,1,1,IACTS,ACTION2,KUN,KNUL,ISTAT)
      PREWHIT = ACTION2.EQ.'Y'.AND.ACTION.NE.'I'
      IF (PREWHIT) THEN
       CALL STKRDR ('PREFREQ',1,1,IACTS,PREFREQ,KUN,KNUL,ISTAT)
       IF (PREFREQ.LE.0.0) THEN
        CALL STTPUT('*** Wrong PREFREQ -> no prewhitening ',ISTAT)
        PREWHIT = .FALSE.
       ENDIF
      ENDIF
C
      CALL STKRDI ('ORDERTSA',1,1,IACTS,ORDERTSA,KUN,KNUL,ISTAT)
      IF (ORDERTSA.LT.0) THEN
       ORDERTSA = 0
       CALL STTPUT('*** Wrong ORDERTSA, set to 0 ',ISTAT)
      ELSEIF (ORDERTSA.GT.9) THEN
       CALL STTPUT('*** Wrong ORDERTSA, set to 9 ',ISTAT)
       ORDERTSA = 9
      ENDIF
      IF (ORDERTSA.NE.1) THEN
       CALL STTPUT('*** Warning: ORDERTSA.ne.1  ',ISTAT)
      ENDIF
C
      CALL STKRDI ('FITITER',1,1,IACTS,FITITER,KUN,KNUL,ISTAT)
      CALL STKRDR ('LOS',1,1,IACTS,LOS,KUN,KNUL,ISTAT)
C
      STARTTSA = START(1)
      STEPTSA  = STEP(1)
      NSTEPTSA = NSTEPS(1)
C
      VSTART = START(2)
      VSTEP  = STEP(2)
      VNSTEP = NSTEPS(2)
      IF (CLEAN) THEN
C
C   Map output table ONAME
C
       CALL TBTOPN (ONAME,F_IO_MODE,TIDO,ISTAT)
       CALL TBIGET (TIDO,NCOLO,NROWO,ISORO,ICOLO,IROWO,ISTAT)
       CALL TBLSER (TIDO,'VEL',  IVEL,ISTAT)
       CALL TBLSER (TIDO,'FREQ', IFREQ,ISTAT)
       CALL TBLSER (TIDO,'DFREQ',IDFREQ,ISTAT)
       CALL TBLSER (TIDO,'PHMT', IPHMT,ISTAT)
       CALL TBLSER (TIDO,'DPHMT',IDPHMT,ISTAT)
       DO 10 I = 1,(2*ORDERTSA+1)
        WRITE (CLAB,'(A,I4.4)') 'C',I
        CALL TBLSER (TIDO,CLAB,IC(I),ISTAT)
 10    CONTINUE
       CALL TBLSER (TIDO,'MAXPOW',IMAXPOW,ISTAT)
C
      ENDIF
C      
C   Loop over columns of table and transform by SCARGLE, CLEAN afterwards
C
      DO 100 III = 1, VNSTEP
C
       VEL = VSTART+(VNSTEP-III)*VSTEP
       POS = VNSTEP-III+1
       WRITE(TEXT,'(A,I3,A,I3,A,F7.1,A)')
     $     'processing column ',III,' of ',VNSTEP, ' at ',VEL
      CALL STTPUT(TEXT,ISTAT)         
C
C   Map next column
C      
      WRITE (CLAB,'(A,I4.4)') 'L',III
      CALL TBLSER (TID,CLAB,IL,ISTAT)
      CALL TBCMAP (TID,IL, PL, ISTAT)
      CALL SETVALUE (MADRID(PVAL),MADRID(PL),NROW)
C
C   Normalize VALUE column
C
      CALL TSANORM (MADRID(PVAL),NROW)
C
C   Prewhiten column VALUE with frequency PREFREQ
C
      IF (PREWHIT) then
       CALL STTPUT('  PREWHITEN: ',ISTAT)
       CALL TSASIN (1,1,DBLE(PREFREQ),PTIME,PVAL,NROW,COEF,OUT)
      ENDIF
C
C   Compute test statistics (SCARGLE) and insert to result frame
C
      SCARGL = .TRUE.
      CALL TSADFT (PTIME,PVAL,NROW,STARTTSA,STEPTSA,NSTEPTSA,
     $             SCARGL,MADRID(PRES),(POS-1)*NSTEPTSA)
C
C   Compute power spectrum and insert to result frame
C
      SCARGL = .FALSE.
      CALL TSADFT (PTIME,PVAL,NROW,STARTTSA,STEPTSA,NSTEPTSA,
     $             SCARGL,MADRID(PPOW),(POS-1)*NSTEPTSA)
C
C   CLEAN algorithm (according to A.S-C)
C
      IF (CLEAN) THEN
       CALL STTPUT('  CLEAN: ',ISTAT)
C
C    Find maximum in Scargle periodogram. 
C     Apply CLEAN only if maximum > level of significance LOS
C
       CALL TSAMAX (MADRID(PRES),(POS-1)*NSTEPTSA,NSTEPTSA,MAX)
       IF (MAX.LE.LOS) THEN
        WRITE(TEXT,'(A,F5.2,A,F5.2,A)')
     $     '  max = ',MAX,' < los = ',LOS, ' -> column skipped'
        CALL STTPUT(TEXT,ISTAT)        
        CALL STTPUT(' ',ISTAT)
       ELSE
C
C    Search and fit most powerful peak in the power spectrum 
C
       BANDW = STEPTSA*NSTEPTSA
       BANDC = STEPTSA*NSTEPTSA+STARTTSA
       CALL TSAWDT (MADRID(PPOW),(POS-1)*NSTEPTSA,STARTTSA,STEPTSA,
     $              NSTEPTSA,BANDW,BANDC,MAXPOW,STATUS)
       IF (STATUS.EQ.-1) GOTO 100
       CALL TBEWRD (TIDO,III,IVEL,DBLE(VEL),ISTAT)
       CALL TBEWRD (TIDO,III,IMAXPOW,MAXPOW,ISTAT)
C
C    Fit sinusoid and write results to table ONAME 
C
       CALL TSASIN (ORDERTSA,FITITER,BANDC,PTIME,PVAL,NROW,COEF,OUT)
C
       CALL TBEWRD (TIDO,III,IFREQ, OUT(1),ISTAT)
       CALL TBEWRD (TIDO,III,IDFREQ,OUT(2),ISTAT)
       CALL TBEWRD (TIDO,III,IPHMT, OUT(3),ISTAT)
       CALL TBEWRD (TIDO,III,IDPHMT,OUT(4),ISTAT)
       DO 20 I = 1,(2*ORDERTSA+1)
        CALL TBEWRD (TIDO,III,IC(I),COEF(I),ISTAT)
 20    CONTINUE
C
C    Store result back to column at velocity vel
C
       CALL SETL (MADRID(PL),MADRID(PVAL),NROW)
C
       CALL STTPUT(' ',ISTAT)
C
       ENDIF
      ENDIF
C
C    End of loop over columns
C
 100  CONTINUE
C
C   wind-up Midas
C
      CALL STSEPI
C
      END
C
C ****************************************************************************
C
C   SUBROUTINES
C
C ****************************************************************************
C
      SUBROUTINE SETVALUE (V,L,N) 
C
      INTEGER N,I
      REAL*8 V(N)
      REAL*4 L(N)
C
      DO 10 I=1,N
       V(I) = DBLE(L(I))  
 10   CONTINUE
      END
C
C ****************************************************************************
C
      SUBROUTINE SETL (L,V,N) 
C
      INTEGER N,I
      REAL*8 V(N)
      REAL*4 L(N)
C
      DO 10 I=1,N
       L(I) = V(I)  
 10   CONTINUE
      END
C
C ****************************************************************************
C
      SUBROUTINE TSANORM (V,N)
C
      INTEGER N,I
      REAL*8 V(N),SUM,MEAN
      REAL*8 ZERO,ONE,HALF,TWO
      DATA   ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      SUM = ZERO
      DO 10 I=1,N
       SUM = SUM+V(I)   
 10   CONTINUE
      MEAN = SUM/DBLE(N)
      DO 20 I=1,N
       V(I) = V(I) - MEAN
 20   CONTINUE
      END
C
C ****************************************************************************
C
      SUBROUTINE TSAMAX (X,OFFSET,N,MAX)
C
      INTEGER N,I,OFFSET
      REAL*8 X(1), MAX
      REAL*8 ZERO,ONE,HALF,TWO
      DATA   ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      MAX = ZERO
      DO 10 I=1,N
       IF (X(OFFSET+1+I).GT.MAX) THEN
        MAX = X(OFFSET+1+I)   
       ENDIF
 10   CONTINUE
      END
C
C ****************************************************************************
C
      SUBROUTINE TSASIN (ORDERTSA,ITER,FREQU,PTIME,PVAL,NROW,COEF,OUT)
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INTEGER      MXORDER
      PARAMETER   (MXORDER=20)          !  DEPENDS ON LENGTH OF OUTD
      REAL*8       FREQU                !  INITIAL PERIOD VALUE
      INTEGER      NORDER               !  NUMBER OF HARMONICS
      INTEGER      ITER                 !  NUMBER OF ITERATIONS
      REAL*8       COEF(MXORDER+3)      !  NORDER COEFFICIENTS
C
      INTEGER      MODE
      INTEGER      NROW,ORDERTSA
      INTEGER      PTIME,PVAL,POTIME,POVAL
      REAL*8 E(MXORDER+3)           ! WORK TABLES
      REAL*8 B(MXORDER+3,MXORDER+3) ! WORK TABLES
      REAL*8 OUT(4)                 ! FREQ,DFREQ,PHMT,DPHMT
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
      DATA MODE/1/
C
C   Set parameters
C
      NORDER = ORDERTSA 
      NORDER = 2*NORDER+2
      POTIME = PTIME
      POVAL  = PVAL
C
C   M. Peron 22-02-93
C   A. Schwarzenberg-Czerny 07-05-93
C
C   Perform single nonlinear fit iteration, store coeficients and residuals
C
      COEF(NORDER)=FREQU
      CALL TIMFIT(MADRID(PTIME),MADRID(PVAL),MADRID(POVAL),NROW,
     $   MODE,NORDER,ITER,MXORDER,COEF,E,B,OUT)
      FREQU=COEF(NORDER)
C
      END
C
C
C ****************************************************************************
C
      SUBROUTINE TIMFIT(T,X,OX,NX,MODE,NORD,NITER,MXORD,F,E,B,O)
C
C     Purpose: Given a trial period, fit a Fourier series by non-linear
C        least squares method.
C
C     Data: an ASCII file containing 3 columns (number of line(integer),
C        time, value (both real*4)) and less than maxm-2 rows.
C        A trial value of the period, an order of the series (<maxo/2-1)
C        and a name of the data file are prompted for.
C
C     Results: Correlation coefficients of the fitted parameters, their
C        values and errors are displayed on the screen after each
C        iteration. Finish iterations by typing 0 when changes in
C        the parameters and std.dev. are negligible. After the final
C        iteration values of the series are subtracted from the data and
C        output as fitsin.res file.
C
C     Method: The data are fitted by the following series:
C        f(1)+f(2)*sin(w*t)+f(3)*cos(w*t)+...+f(2*ord+1)*cos(2*ord*w*t)
C        by least squares. After the initial solution
C        the value of the frequency w is varied as well as the coefficients so
C        that due to nonlinearity of the problem several iterations are
C        required. To continue iterations type 1.
C
C     A. Schwarzenberg-Czerny                      June, 1987
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INTEGER NX                 !  NUMBER OF DATA
      REAL*8  CRACOW             !  EXTERNAL FUNCTION
      REAL*8  T(NX)              !  TIME VECTOR
      REAL*8  X(NX)              !  INPUT DATA VECTOR
      REAL*8  OX(NX)             !  OUTPUT DATA VECTOR
      INTEGER MODE               !  MODE OF WORK
      INTEGER NORD               !  ORDER OF THE SERIES
      INTEGER MXORD              !  TABLE SIZE-3
      INTEGER NITER              !  NUMBER OF ITERATIONS
      REAL*8  F(MXORD+3)         !  FIT COEFFICIENTS (INCL. FREQ)
      REAL*8  O(4)     !  FREQ,DFREQ,PHMT,DPHMT
      REAL*8 E(MXORD+3),B(MXORD+3,MXORD+3)   ! WORK TABLES
C
      REAL*8  FREQ
      LOGICAL START
      CHARACTER*80 MSG
      REAL*8 TM,XM,TMX,TMI,DFREQ,PI2,CORRMX
      REAL*8 PHMT,DPHMT,EPMAX, FREQSTEP
      INTEGER N,NP,I,N1,J,K,ITER
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
C    get data
C
      PI2=TWO*TWO*TWO*ATAN(ONE)
      START=NITER.GT.0
      NITER = IABS(NITER)
      ITER=0
      TM=ZERO
      XM=ZERO
      TMX=T(1)
      TMI=TMX
      DO 1 I=1,NX
        TMX=MAX(TMX,T(I))
        TMI=MIN(TMI,T(I))
        TM=TM+T(I)
 1      XM=XM+X(I)
      TM=TM/NX
      XM=XM/NX
C
C    input parameters and output results of previous iteration
C
      IF (MODE.EQ.1) THEN
        IF (NORD.LT.1) CALL STETER(5,'Wrong parameter')
        F(NORD)=PI2*F(NORD)
        NP=2
        IF (START) THEN
           WRITE(MSG,'(a,1pg20.6,a,i4)')
     $         '  START: frequency=',F(NORD)/PI2,' order=',(NORD-2)/2
           CALL STTPUT(MSG,ISTAT)
           N=NORD-1
           DFREQ=ZERO
        ELSE
          N=NORD
        ENDIF
      ELSE
        CALL STETER(2,' Wrong mode')
      ENDIF
      IF (START) THEN
        DO 5 I=1,N
 5         F(I)=ZERO
      ENDIF
C
C    iterations for non-linear fit
C
 100  CONTINUE
C
C           freq - current frequency
C           dfreq - its error
C           tm - mean time of observation
C           phmt - phase of base sinusoid at mean time
C           dphmt - its error
C           epmax - epoch of maximum of the base sinusoid
C           The harmonics are ignored by phase calculation
C
C
C     set condition and normal equations
C
        N1=N+1
        ITER=ITER+1
        DO 60 I=1,N1
          DO 60 J=1,N1
 60         B(J,I)=ZERO
        DO 3 I=1,NX
          F(NORD+1)=T(I)-TM
          F(NORD+2)=X(I)-XM
          IF (MODE.EQ.1) THEN
            CALL FITSIN(E,N1,F,NP)
          ENDIF
C  *** prevent overwriting data before end of iterations, A.S-C, 07-05-93
          IF (ITER.GT.NITER) THEN
            OX(I)=E(N1)
          ENDIF
          DO 3 J=1,N1
            DO 3 K=1,N1
 3            B(K,J)=B(K,J)+E(J)*E(K)
C
C     solve normal equations and evaluate results
C
        IF (ITER.LE.NITER) THEN
          IF (CRACOW(B,N1,MXORD+3,NX).NE.ZERO) THEN
C
C   Update and output coefficients
C
            CORRMX=ZERO
            DO 7 J=1,N
              F(J)=F(J)+B(J,N1)
              DO 7 I=1,J-1
 7              CORRMX=MAX(CORRMX,ABS(B(I,J)/SQRT(B(J,J)*B(I,I))))
            IF (ITER.LE.1) THEN
CAK              CALL STTPUT(
CAK     $        '   iter.        freq.       std.dev.,     max. corr.',
CAK     $          ISTAT)
            ELSE
              FREQSTEP=B(NORD,N1)/PI2
              IF (FREQSTEP*(TMX-TMI).GT.TWO) THEN
                CALL STTPUT(
     $            '  *** Large frequency step, divergence?',ISTAT)
              ENDIF
            ENDIF
CAK            WRITE(MSG,'(1x,i7,3(1pe15.7),'' '')')
CAK     $         ITER,F(NORD)/PI2,SQRT(MAX(B(N1,N1),ZERO)),CORRMX
CAK            CALL STTPUT(MSG,ISTAT)
            IF (ITER.EQ.NITER) THEN
CAK              CALL STTPUT('   coefficients     errors',ISTAT)
              F(1)=F(1)+XM
CAK              DO 6 J=1,N
CAK                WRITE(MSG,'(1x,2(1pe15.7),'' '')')
CAK     $                F(J),SQRT(MAX(B(J,J),ZERO))
CAK 6            CALL STTPUT(MSG,ISTAT)
              F(1)=F(1)-XM
C
C   Output ephemeris for base sinusoid
C
              IF (NORD.GT.ZERO.AND.MODE.EQ.1) THEN
                FREQ=F(NORD)/PI2
                IF(.NOT.START) DFREQ=SQRT(MAX(B(N,N),ZERO))/PI2
                PHMT=ATAN2(F(3),F(2))/PI2
                DPHMT=SQRT(F(2)*F(2)*B(3,3)+F(3)*F(3)*B(2,2))/
     $             (F(2)*F(2)+F(3)*F(3))
                EPMAX=(HALF*HALF-PHMT)/FREQ+TM
                IF (PHMT.LT.ZERO) PHMT=PHMT+ONE
                MSG='   frequency        error         '//
     $            'phase at m.t.  error        '
                CALL STTPUT(MSG,ISTAT)
                WRITE(MSG,'(1x,5(1pe15.7))') FREQ,DFREQ,PHMT,DPHMT
                CALL STTPUT(MSG,ISTAT)
C  extended output
                O(1) = FREQ
                O(2) = DFREQ
                O(3) = PHMT
                O(4) = DPHMT
C
CAK                CALL STTPUT(
CAK     $          '   epoch of max.    mean time    ',ISTAT)
CAK                WRITE(MSG,'(1x,5(1pe15.7))') EPMAX,TM
CAK                CALL STTPUT(MSG,ISTAT)
              ENDIF
            ENDIF
C
C      next iterations with period correction
            N=NORD
            START=.FALSE.
            GOTO 100
          ELSE
CAK            CALL STETER(4,
CAK     $          ' Singular equations, or wrong dimensions ')
            CALL STTPUT('Singular equations, or wrong dimensions',ISTAT)
            N=NORD
            START=.FALSE.
            GOTO 100
          ENDIF
        ENDIF
C        end loop 100
      IF (MODE.EQ.1) THEN
        F(NORD)=F(NORD)/PI2
        F(NORD+1)=F(NORD+1)/PI2
      ENDIF
      END
C
C
C ****************************************************************************
C
      SUBROUTINE FITSIN(E,N1,P,NP)
C
C    condition equations for fit of Fourier series,
C    last term contains residuals
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
C
      INTEGER N1,NP
      REAL*8 E(N1),P(N1-1+NP)
C
      INTEGER J,NORD,NFR,L
      REAL SJ,CJ,T,X,FR,S,C,RHS,SAVE
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      NORD=(N1-2)/2
      NFR=2*(NORD+1)
      T=P(NFR+1)
      X=P(NFR+2)
      FR=P(NFR)
      S=SIN(T*FR)
      C=COS(T*FR)
      SJ=S
      CJ=C
      E(NFR)=ZERO
      E(1)=ONE
      RHS=X-P(1)
      DO 4 J=1,NORD
        L=2*J
        E(L)=SJ
        E(L+1)=CJ
        E(NFR)=E(NFR)+J*T*(P(L)*CJ-P(L+1)*SJ)
        RHS=RHS-P(L)*SJ-P(L+1)*CJ
        SAVE=CJ*C-SJ*S
        SJ=CJ*S+SJ*C
 4      CJ=SAVE
      E(N1)=RHS
      END
C
C
C **********************************************************************
C
      SUBROUTINE TSADFT (PTIME,PVAL,NROW,STARTTSA,STEPTSA,NSTEPTSA,
     $                   SCARGL,PER,OFFSET)
C
C     Compute discrete or Scargle power spectra
C
      IMPLICIT NONE
      INTEGER  ISTAT
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      REAL*8       START(2)            
      REAL*8       STEP(2)             
      INTEGER      NSTEPS(2),NROW,OFFSET           
C
      REAL*8       STARTTSA,STEPTSA
      INTEGER      NSTEPTSA
      LOGICAL      SCARGL
      INTEGER      PTIME,PVAL,PWORK,IDWORK,PWORKP,IDWORKP
C
      REAL*8       PER(1)
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Map temporary frame
C
      START(1) = STARTTSA
      STEP(1)  = STEPTSA
      NSTEPS(1)= NSTEPTSA
      START(2) = 0.
      STEP(2)  = 1.
      NSTEPS(2)= 2.
C     temporal workframe
      CALL STIPUT ('middummwork',D_R8_FORMAT,
     $            F_IO_MODE,F_IMA_TYPE,2,NSTEPS,
     $   START,STEP,'middummwork',
     $   'Temporary image',PWORK,IDWORK,ISTAT)
C
C     temporal result frame
      CALL STIPUT ('middummworkp',D_R8_FORMAT,
     $            F_IO_MODE,F_IMA_TYPE,2,NSTEPS,
     $   START,STEP,'middummworkp',
     $   'perigram',PWORKP,IDWORKP,ISTAT)
C
C   Compute DFT periodogramme
C
      CALL TIMEDFT (MADRID(PTIME),MADRID(PVAL),
     $    PER(1+OFFSET),MADRID(PWORKP),MADRID(PWORK),
     $    NROW,NSTEPS(1),START(1),STEP(1),SCARGL)
C
      END
C
C
C ****************************************************************************
C
      SUBROUTINE TSAWDT (PER,OFFSET,STARTTSA,STEPTSA,NSTEPTSA,
     $                   BANDW,BANDC,VALLINE,STATUS)
C
      IMPLICIT NONE
      INTEGER  ISTAT,STATUS
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INCLUDE 'MID_INCLUDE:ST_DEF.INC'
C
      INTEGER      NAXIS,NVALUES
      PARAMETER   (NAXIS=2,NVALUES=5)
      
      REAL*8       PER(1)               !  INPUT FRAME    
      REAL*8       BANDW                !  INPUT BAND WIDTH
      REAL*8       BANDC                !  INPUT BAND CENTRE
      INTEGER      OFFSET
C
      REAL*8       STARTTSA,STEPTSA
      REAL*8       WIDTH(NVALUES,2),VALLINE
      INTEGER      NSTEPTSA
      INTEGER      IACTS
      INTEGER      PWORK,IWORK
C
      INTEGER      MADRID
C
      COMMON /VMR/ MADRID(1)
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/

      INCLUDE 'MID_INCLUDE:ST_DAT.INC'
C
C   Create work table
C
      CALL STFCRE('middummwork',D_R8_FORMAT,F_IO_MODE,F_IMA_TYPE,
     $            NSTEPTSA,IWORK,ISTAT)
      CALL STFMAP(IWORK,F_IO_MODE,1,NSTEPTSA,IACTS,PWORK,ISTAT)
C
C   Evaluate frequency band
C
      CALL TIMWIDTH(PER(1+OFFSET),MADRID(PWORK),NSTEPTSA,STARTTSA,
     $              STEPTSA,BANDW,BANDC,NVALUES,WIDTH,VALLINE)
C
      END
C
C ********************************************************************
C
      SUBROUTINE  TIMWIDTH(PER,WORK,
     $    NSTEPS,START,STEP,BANDW,BANDC,NVALUES,WIDTH,VALLINE)
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      REAL*8       CRACOW
      INTEGER      NSTEPS,NVALUES
      REAL*8       PER(NSTEPS),WORK(NSTEPS)
      REAL*8       START,STEP,BANDW,BANDC
      REAL*8       WIDTH(NVALUES,2)
C
      INTEGER      NPAR1
      PARAMETER   (NPAR1=4)
      REAL*8       FINISH
      REAL*8       COND(NPAR1),COVAR(NPAR1,NPAR1)
      REAL*8       VALPEAK,VALLINE,VALCONT,VALHALF,VAL
      REAL*8       PEAKC,LINEC,PEAKW,LINEW,X
      INTEGER      IPEAKC,IPEAKW
      INTEGER      ISTART,NBAND
      INTEGER      I,J,K,ITER,MXITER,IVAL,MODE
      CHARACTER*80 TEXT
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      DATA         MXITER/10/
C
C      Get (trimmed) range of pixels
C
      IF (STEP.EQ.ZERO) THEN
        CALL STETER(10,'Zero step: check descriptor STEP(1)')
      ENDIF
      FINISH=STEP*NSTEPS
      VAL=BANDC-START
      ISTART= MIN(NSTEPS,MAX(1,NINT(
     $     MIN(FINISH,MAX(ZERO,VAL-BANDW))/STEP)))-1
      NBAND= MIN(NSTEPS,MAX(1,NINT(
     $     MIN(FINISH,MAX(ZERO,VAL+BANDW))/STEP)))
      NBAND=NBAND-ISTART
      IF (NBAND.LT.10) THEN
        CALL STETER(11,'Too narrow band')
      ENDIF
C
C   Compute pixel histogramme and find continuum as median value
C
      DO 1 I=1,NBAND
        WORK(I)=PER(ISTART+I)
 1    CONTINUE
      CALL SORT(NBAND,WORK)
      VALPEAK=WORK(NBAND)
      VALCONT=WORK(NBAND/2+1)
CAK      CALL STTPUT('   ---    Line Parameters    ---',ISTAT)
CAK      CALL STTPUT(
CAK     $   'Component    Level      Frequency                Width',
CAK     $   ISTAT)
CAK      WRITE(TEXT,'(A,1PE10.2,1PE13.5,11X,1PE10.2)')
CAK     $     'Continuum ',VALCONT,BANDC,BANDW
CAK      CALL STTPUT(TEXT,ISTAT)
C
C   Find approximate parameters of the line
C
      VALHALF=(VALPEAK+VALCONT)*HALF
      IPEAKC=0
      DO 2 I=1,NBAND
        IF (PER(ISTART+I).EQ.VALPEAK) THEN
          IPEAKC=ISTART+I
        ENDIF
        IF (WORK(I).LT.VALHALF) THEN
          IPEAKW=I
        ENDIF
 2    CONTINUE
      PEAKW=(VALHALF-WORK(IPEAKW))/(WORK(IPEAKW+1)-WORK(IPEAKW))
      PEAKW=(NBAND-(IPEAKW*(ONE-PEAKW)+(IPEAKW+1)*PEAKW))*STEP*HALF
      IF (IPEAKC.EQ.0) THEN
        CALL STETER(12,'Coding error: condition should not occure')
      ENDIF
      PEAKC=START+STEP*IPEAKC
CAK      WRITE(TEXT,'(A,1PE10.2,1PE13.5,A,1PE7.1,1PE10.2,A,1PE7.1)')
CAK     $    'Peak      ',VALPEAK,PEAKC,' +/-',STEP,PEAKW,' +/-',STEP
CAK      CALL STTPUT(TEXT,ISTAT)
      BANDC=PEAKC
C
C   Fit a line by nonlinear least squares iterations
C
      LINEC=PEAKC
      LINEW=PEAKW
      VALLINE=VALPEAK
      ITER=0
 19   CONTINUE
        ITER=ITER+1
        IF (ITER.EQ.1) THEN
          VAL=LINEC-START
          ISTART= MIN(NSTEPS,MAX(1,NINT(
     $       MIN(FINISH,MAX(ZERO,VAL-TWO*LINEW))/STEP)))-1
          I     = MIN(NSTEPS,MAX(1,NINT(
     $       MIN(FINISH,MAX(ZERO,VAL+TWO*LINEW))/STEP)))
          NBAND=  I-ISTART
          IF (NBAND.LT.4) THEN
            CALL STTPUT('Line very narrow: poor results',ISTAT)
            ISTART= MIN(NSTEPS,MAX(1,(ISTART+I)/2-2))
            NBAND=4
          ENDIF
        ENDIF
        DO 10 J=1,NPAR1
          DO 11 K=1,NPAR1
            COVAR(J,K)=ZERO
 11       CONTINUE
 10     CONTINUE
        MODE=1
        DO 15 I=1,NBAND
          J=ISTART+I
          X=START+J*STEP-LINEC
          CALL PROFILE(LINEW,VALLINE-VALCONT,X,PER(J)-VALCONT,
     $         COND,NPAR1,MODE)
          DO 16 J=1,NPAR1
            DO 17 K=1,NPAR1
              COVAR(J,K)=COVAR(J,K)+COND(J)*COND(K)
 17         CONTINUE
 16       CONTINUE
 15     CONTINUE
        IF (CRACOW(COVAR,NPAR1,NPAR1,NBAND).EQ.ZERO) THEN
          CALL STTPUT('Singular conditions for profile', ISTAT)
          STATUS=-1
          RETURN
CAK          CALL STETER(15,'Singular conditions for profile')
        ENDIF
C
C   Take care of initial convergence
C
        VAL= EXP(-(ZERO+ITER-ONE)/ONE)
        VAL= 0.1*VAL+ONE*(ONE-VAL)
        LINEC=   LINEC  +    COVAR(1,NPAR1)*VAL
        LINEW=   LINEW  *EXP(COVAR(2,NPAR1)*VAL)
        VALLINE= VALLINE*EXP(COVAR(3,NPAR1)*VAL)
        VAL=COVAR(1,NPAR1)*COVAR(1,NPAR1)+COVAR(2,NPAR1)*COVAR(2,NPAR1)
      IF (SQRT(VAL).GT.ONE/NSTEPS*0.1 .AND. ITER.LT.MXITER) GOTO 19
      VAL=COVAR(NPAR1,NPAR1)/VALCONT/VALCONT
      IF (VAL.GT.ONE) THEN
        WRITE(TEXT,'(A,F12.2,A)')
     $    '  *** Warning: Poor fit (RMS= ',SQRT(VAL),'*Cont.)'
        CALL STTPUT(TEXT,ISTAT)
      ENDIF
C
C   Print report
C
      IF (ITER.GE.MXITER) THEN
         CALL STTPUT('  *** Warning: No convergence of fit',ISTAT)
      ELSE
        BANDC=LINEC
      ENDIF
      WRITE(TEXT,'(A,1PE10.2,1PE13.5,A,1PE7.1,1PE10.2,A,1PE7.1)')
     $  '  Fit  : ',VALLINE,
     $   LINEC,'+/-',SQRT(COVAR(1,1)*COVAR(NPAR1,NPAR1)),
     $   LINEW,'+/-',SQRT(COVAR(2,2)*COVAR(NPAR1,NPAR1))
      CALL STTPUT(TEXT,ISTAT)
C
C   Compute profile width at NVALUES levels
C
      MODE=2
CAK      CALL STTPUT('   ---  Fitted Line Profile  ---',ISTAT)
CAK      CALL STTPUT('    Width      Level     Fraction',ISTAT)
      DO 20 IVAL=1,NVALUES
        VAL=(IVAL-ONE)/(NVALUES-ONE)
        VAL=((ONE-VAL)*(VALLINE-VALCONT-VALCONT)+VAL*VALCONT)
        WIDTH(IVAL,2)=VAL+VALCONT
        CALL PROFILE(LINEW,VALLINE-VALCONT,WIDTH(IVAL,1),VAL,
     $     COND,NPAR1,MODE)
CAK        WRITE(TEXT,'(4(1PE11.2))') WIDTH(IVAL,1),WIDTH(IVAL,2),
CAK     $    (VALLINE-WIDTH(IVAL,2))/(VALLINE-VALCONT)
CAK        CALL STTPUT(TEXT,ISTAT)
 20   CONTINUE
      END
C
C
C *********************************************************************
C
      SUBROUTINE PROFILE(W,H,X,Y,COND,NPAR1,MODE)
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INTEGER      NPAR1,MODE
      REAL*8       COND(NPAR1)
      REAL*8       W,H,X,Y
C
      REAL*8       PI,FI,DFIDX,H2,DFDFI,F,WEIGHT
      INTEGER      I
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      PI=TWO*TWO*ATAN(ONE)
      IF (MODE.EQ.1) THEN
        DFIDX=PI*HALF/W
        FI=MAX(-PI,MIN(PI,DFIDX*X))
        H2=H*HALF
        F=(COS(FI)+ONE)*H2
        DFDFI=-H2*SIN(FI)
        COND(1)=-DFDFI*DFIDX
        COND(2)=DFDFI*(-FI/W)*W
        COND(3)=F/H*F
        COND(NPAR1)=Y-F
        WEIGHT=F/H
        DO 1 I=1,NPAR1
          COND(I)=COND(I)*WEIGHT
 1      CONTINUE
      ELSEIF (MODE.EQ.2) THEN
        X=TWO*W/PI*ACOS(MIN(ONE,MAX(-ONE,(TWO*Y/H-ONE))))
      ELSE
        CALL STETER(20,'Wrong mode')
      ENDIF
      END
C
C
C ***********************************************************************
C
      SUBROUTINE TIMEDFT (T,X,PER,P,W,N,NFREQ,FREQIN,FSTEP,SCARGL)
C
C   Fourier and normalized Scargle power spectrum
C   (see ApJ 338,277 & ApJ 263,835)
C   Scargle method implementation sufferes from numerical
C   rounding errors.
C                               alex schwarzenberg-czerny, november 85
C
      IMPLICIT NONE
      INTEGER  ISTAT
      INTEGER  ISTORE
      REAL*8   ZERO,ONE,HALF,TWO
C
      INTEGER N
      INTEGER NFREQ
      REAL*8  T(N),X(N)
      REAL*8  P(NFREQ,2),W(NFREQ,2),PER(NFREQ)
      REAL*8  FREQIN,FSTEP
      LOGICAL SCARGL
C
      INTEGER I,IF
      REAL*8  PI2,START,STEP,EN,ANORM,CSTEP,SSTEP,ARC,C,S
      REAL*8  XX,TT,XVAR,TVAR,XAV,TAV,XTCOR,SING
      REAL*8  SAVE,PHA,CPHA,SPHA
C
      DATA         ISTORE,ISTAT /1,0/
      DATA         ZERO,ONE,HALF,TWO/0D0,1D0,0.5D0,2D0/
C
      PI2=   ATAN(ONE)*TWO*TWO*TWO
      START= FREQIN*PI2
      STEP=  FSTEP*PI2
C
      DO 3 IF=1,NFREQ
        DO 3 I=1,2
          P(IF,I)=ZERO
 3        W(IF,I)=ZERO
C
C
C
      XAV=   ZERO
      TAV=   ZERO
      XVAR=  ZERO
      TVAR=  ZERO
      DO 10 I=1,N
        EN=   I
        TT=   T(I)
        XX=   X(I)
C
        SAVE= TAV+(TT-TAV)/EN
        TVAR= TVAR+(TT-TAV)*(TT-SAVE)
        TAV=  SAVE
C
        SAVE= XAV+(XX-XAV)/EN
        XVAR= XVAR+(XX-XAV)*(XX-SAVE)
        XAV=  SAVE
 10   CONTINUE
C
C
C
      EN=    N
      XTCOR= ZERO
      DO 2 I=1,N
        TT    =T(I)-TAV
        IF (SCARGL) THEN
          XX    =X(I)-XAV
        ELSE
          XX    =X(I)
        ENDIF
        XTCOR =XTCOR+TT*XX
C
        ARC   =STEP*TT
        CSTEP =COS(ARC)
        SSTEP =SIN(ARC)
C
        ARC   =START*TT
        C     =COS(ARC)
        S     =SIN(ARC)
C
        DO 1 IF=1,NFREQ
          P(IF,1)=P(IF,1)+XX*C
          P(IF,2)=P(IF,2)+XX*S
          IF (SCARGL) THEN
            W(IF,1)=W(IF,1)+C*C-HALF
            W(IF,2)=W(IF,2)+S*C
          ELSE
            W(IF,1)=W(IF,1)+C
            W(IF,2)=W(IF,2)+S
          ENDIF
          SAVE=C*CSTEP-S*SSTEP
          S=   C*SSTEP+S*CSTEP
          C=   SAVE
 1      CONTINUE
 2    CONTINUE
C
      IF (SCARGL) THEN
        SING=XTCOR*XTCOR/TVAR*HALF*EN
        XVAR=XVAR/(EN-ONE)
        TVAR=TVAR/(EN-ONE)
        ANORM=ONE/XVAR/EN
      ELSE
        ANORM=ONE/EN/EN
      ENDIF
C
      DO 4 I=1,NFREQ
        IF (SCARGL) THEN
          PHA  =ATAN2(W(I,2),W(I,1))/TWO
          CPHA =COS(PHA)
          SPHA =SIN(PHA)
          C    =P(I,1)*CPHA-P(I,2)*SPHA
          S    =P(I,2)*CPHA+P(I,1)*SPHA
          SPHA   =TWO*SPHA*CPHA
          CPHA   =TWO*CPHA*CPHA-ONE
          CSTEP  =(W(I,1)*CPHA-W(I,2)*SPHA)*TWO
C          SSTEP  =(W(I,2)*CPHA+W(I,1)*SPHA)*TWO
          CSTEP  =CSTEP/EN
          SAVE =(ONE+CSTEP)*(ONE-CSTEP)
          P(I,2)=SAVE
          IF (SAVE.GT.0.001) THEN
            P(I,1) =(C*C/(ONE+CSTEP)+S*S/(ONE-CSTEP))*ANORM
          ELSE
            IF (CSTEP.GT.ZERO) THEN
              P(I,1) =(C*C/(ONE+CSTEP)+SING)*ANORM
            ELSE
              P(I,1) =(SING+S*S/(ONE-CSTEP))*ANORM
            ENDIF
          ENDIF
        ELSE
          P(I,1) =(P(I,1)*P(I,1)+P(I,2)*P(I,2))*ANORM
          P(I,2) =(W(I,1)*W(I,1)+W(I,2)*W(I,2))/EN
        ENDIF
        PER(I) = P(I,1)
 4    CONTINUE
      END
 

