C @(#)xcenter.for      4.1.1.2 (ESO-IPG)  
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                            all rights reserved
C.IDENTIFICATION: CENTLINE
C.PURPOSE:        non-interactive line centering. output stored in a table
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         A.Kaufer
C.KEYWORDS:       Line, centre
C.ALGORITHM:      Line center is found by:
C                 gaussian        - center of the fitted gaussian
C.INPUT/OUTPUT:   non-interactive input via table
C                 table columns :
C	          :FILE
C                  :JD24
C
C.VERSION: 840328  JDP  Creation   
C.VERSION: 870115  JDP  ??   
C.VERSION: 880703  RHW  ESO-FORTRAN Conversion 
C.VERSION: 900430  RHW  Map plotted line separately 
C.VERSION: 932510       Modified to non-interactive input
C.VERSION: 932610                   use images from catalog
C-----------------------------------------------------------------
      PROGRAM   XCENTR
C
      IMPLICIT  NONE
C
      INTEGER   MADRID
      INTEGER   I1,I2,IAC,IACT,IAV,IFAIL,II,II1,IMETH,NPTS
      INTEGER   IMODE,IPL1,IPL2,ISEQ,ISORT,ISTAT
      INTEGER   L,NAXIS,NCOLS,NCOUNT,NNCOL,NPL,NL
      INTEGER   NVAL, NSIZE(2)
      INTEGER   PNTRI, PNTRW, PNTRT
      INTEGER   IMNOI, IMNOT, IMNOW
      INTEGER   IMAGE(4)
      INTEGER   NPIX(2),NN
      INTEGER   KEY
      INTEGER   APPFLG
      INTEGER   STATUS,IC(12)
      INTEGER   KUN, KNUL, TID, ACOL, AROW
      INTEGER   ACCESS, PLMODE
      INTEGER   X1COL, C2COL, IDCOL
      INTEGER   IMA,NOENT,NLAST,NEXT
      INTEGER   DACTS,DUN,DNUL,FILECOL
      INTEGER   NOELM,BYTELM
C
      REAL      SXY,X1,X2,XYS,XLAM,SDEV
      REAL      XCUR,YCUR,PXVL,RRBUF(5),CHISQR
      REAL      VALUE(12),W1(1024),W2(1024),ACOE(4),DACOE(4)
C
      DOUBLE PRECISION START(2),STEP(2)
      DOUBLE PRECISION DXYS, DSXY, JD24, DSDEV
 
      CHARACTER CNAME*40,TNAME*40,INAME*40,INFO*40,METH*2,ID*12
      CHARACTER TABLE*64,TABU(12)*16,TABL(12)*16,ITABL(3)*16,IEA*1
      CHARACTER CLINE*132,HEAD1*72,HEAD2*72,FORM(12)*6,PROMPT*72,IAPP*1
      CHARACTER IDENT*72,CUNIT*48,COML*80,TYPE*1

      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST' 
      INCLUDE   'MID_INCLUDE:PLTDEC.INC/NOLIST' 
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C
      DATA      NCOLS/12/
      DATA      TABU/' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '/
      DATA      TABL/'JD24','XCEN','DXCEN','VRAD','DVRAD',
     2               'INT','DINT','FWHM','DFWHM','WLAM','DWLAM',
     3               'CHISQR'/
      DATA      FORM/'F10.4','F10.3','F10.3','F7.1','F7.1',
     2               'F7.3','F7.3','F8.4','F8.4','F8.1','F8.1',
     3               'F13.4'/
      DATA      HEAD1/
     2  '                                                       '/
C
 9000 FORMAT(A18,F10.4,2F10.3,2F7.1,2F7.3,2F8.4,2F8.1,F13.4)
C
C  *** start of executable code ***************************************
C
      CALL STSPRO('XCENTER')                                      !  initialize
C
C  *** get parameters *************************************************
C
C  **** name of catalog
C
      CALL STKRDC('P1',1,1,20,IACT,INFO,KUN,KNUL,STATUS)
      L     = INDEX(INFO//' ',' ') - 1
      CNAME = INFO(1:L)
C
C **** name of output table
C
      CALL STKRDC('P2',1,1,20,IACT,INFO,KUN,KNUL,STATUS)
      L     = INDEX(INFO//' ',' ') - 1
      TNAME = INFO(1:L)
C
C **** method and related parameters
C
      CALL STKRDC('P3',1,1,80,IACT,COML,KUN,KNUL,STATUS)
      METH   = COML(1:2)
      IF (METH.EQ.'GA') THEN
         IMETH  = -1
         NCOLS=12
         CALL STKRDR('INPUTR',1,1,IACT,X1,KUN,KNUL,STATUS)
         CALL STKRDR('INPUTR',2,1,IACT,X2,KUN,KNUL,STATUS)
         CALL STKRDR('INPUTR',3,1,IACT,XLAM,KUN,KNUL,STATUS)
c      ELSE
      END IF
C
C **** emission or absorption line
C
      CALL STKRDC('P5',1,1,1,IACT,IEA,KUN,KNUL,STATUS)
      CALL UPCAS(IEA,IEA)
      IF (IEA.EQ.'E') THEN
         IMODE  = 1
      ELSE
         IMODE  = 0
      END IF
C
C *** open table for storage of data
C
      CALL TBTINI(TNAME,F_TRANS,F_O_MODE,12,500,TID,STATUS)
C
      CALL TBCINI(TID,D_C_FORMAT,16,'A16',' ','file',FILECOL,STATUS)
      
      CALL TBCINI(TID,D_R8_FORMAT,1,FORM(1),TABU(1),
     +              TABL(1),IC(1),STATUS)
      DO 20 IAV = 2,NCOLS
        CALL TBCINI(TID,D_R4_FORMAT,1,FORM(IAV),TABU(IAV),
     +              TABL(IAV),IC(IAV),STATUS)
   20 CONTINUE
C
C *** write header
C
      IF (IMETH.EQ.-1) THEN
         CALL STTPUT(HEAD1,STATUS)
c      ELSE
      END IF
      CALL STTPUT(' ',STATUS)
C     
C *** loop on input - images from catalog
C
      ISEQ = 0
C **** get number of entries in catalog
C
      CALL STCSHO(CNAME,NOENT,NLAST,STATUS)
C
      DO 30 IMA = 1,NOENT
C
C **** read next image from catalog
C
      CALL STCGET(CNAME,0,INFO,IDENT,NEXT,STATUS)
C      L     = INDEX(INFO,'.bdf') - 1
C      INAME = INFO(1:L)
C      CALL STIGET(INAME,D_R4_FORMAT,0,F_IMA_TYPE,2,
C     +     NAXIS,NPIX,START,STEP,IDENT,CUNIT,PNTRW,IMNOI,ISTAT) 
      INAME = INFO
      CALL STIGET(INAME,D_R4_FORMAT,F_I_MODE,F_IMA_TYPE,2,
     +     NAXIS,NPIX,START,STEP,IDENT,CUNIT,PNTRW,IMNOI,ISTAT) 

      CALL STDFND(IMNOI,'DTIME',TYPE,NOELM,BYTELM,STATUS)

      IF (TYPE.NE.' ') THEN 
         CALL STDRDD(IMNOI,'DTIME',4,1,DACTS,JD24,DUN,DNUL,STATUS)
      ELSE
         CALL STDFND(IMNOI,'O_TIME',TYPE,NOELM,BYTELM,STATUS)
         IF (TYPE.NE.' ') THEN 
            CALL STDRDD(IMNOI,'O_TIME',4,1,DACTS,JD24,DUN,DNUL,STATUS)
         ELSE
            WRITE(CLINE,*) 
     +           'descriptor DTIME/O_TIME not found, exiting'
            CALL STTPUT(CLINE,STATUS)
            STOP
         ENDIF
      ENDIF
         
      VALUE(1) = REAL(JD24)
      SXY  = STEP(1)
      XYS  = START(1)
      DSXY = STEP(1)
      DXYS = START(1)
      II1  = 16*NAXIS
C
      IPL1   = NINT((X1-XYS)/SXY) + 1
      IPL2   = NINT((X2-XYS)/SXY) + 1
      I1     = MIN(IPL1,IPL2)
      I2     = MAX(IPL1,IPL2)
C
C     get mean standard dev per pixel
C
       CALL STDFND(IMNOI,'SDEV',TYPE,NOELM,BYTELM,STATUS)
       IF (TYPE.NE.' ') THEN 
          CALL STDRDD(IMNOI,'SDEV',1,1,DACTS,DSDEV,DUN,DNUL,STATUS)
       ELSE
       WRITE(CLINE,*) 
     + 'descriptor SDEV/R/1/1 not found, using SDEV=0.01'
          CALL STTPUT(CLINE,STATUS)
          DSDEV=0.01
       ENDIF
       SDEV = DSDEV                     ! was FLOAT(DSDEV)
C
C *** find center
C
       CALL FIND(MADRID(PNTRW),SDEV,DXYS,DSXY,I1,I2,IMODE,IMETH,
     2      IFAIL,W1,W2,ACOE,DACOE,CHISQR)
       
C center:
      VALUE(2) = ACOE(2)
      VALUE(3) = DACOE(2)
C
      IF (XLAM.GT.0) THEN
C vrad
         VALUE(4) = 3.0E5*(VALUE(2)-XLAM)/XLAM
         VALUE(5) = 3.0E5*(VALUE(3))/XLAM
      ELSE
C vrad
         VALUE(4) = VALUE(2)
         VALUE(5) = VALUE(3)
      ENDIF
C int
      VALUE(6) = ACOE(1)+ACOE(4)
      VALUE(7) = SQRT(DACOE(1)**2+DACOE(4)**2)
C fwhm
      VALUE(8) = ACOE(3)
      VALUE(9) = DACOE(3)
C
      IF (XLAM.GT.0) THEN
C wlam (mA) cont=acoe(4)
         VALUE(10) = -1.064467*1000.*ACOE(3)*ACOE(1)/ACOE(4)
         VALUE(11) = VALUE(10)*SQRT((DACOE(3)/ACOE(3))**2+
     2        (DACOE(1)/ACOE(1))**2+(DACOE(4)/ACOE(4))**2)

      ELSE
C integrated intensity cont=acoe(4)
         VALUE(10) = ACOE(3)*(ACOE(1)-ACOE(4))
         VALUE(11) = VALUE(10)*SQRT((DACOE(3)/ACOE(3))**2+
     2        ((DACOE(1)**2+DACOE(4)**2)/(ACOE(1)-ACOE(4))**2))      
      ENDIF
C
C chisqr
      VALUE(12) = CHISQR
C     
      IF (IFAIL.EQ.0) THEN
         ISEQ   = ISEQ + 1
         IF (IMETH.EQ.-1) THEN
            CALL TBEWRC(TID,ISEQ,FILECOL,INAME,STATUS)
            CALL TBRWRD(TID,ISEQ,1,IC(1),JD24,STATUS)
            CALL TBRWRR(TID,ISEQ,11,IC(2),VALUE(2),STATUS)
            WRITE (CLINE,9000) INAME(1:18),VALUE(1),VALUE(2),VALUE(3),
     +                         VALUE(4),VALUE(5),VALUE(6),VALUE(7),
     +                         VALUE(8),VALUE(9),VALUE(10),VALUE(11),
     +                         VALUE(12)
         ENDIF
         CALL STTPUT(CLINE,STATUS)
      END IF
C 
      CALL STFCLO(IMNOI,ISTATUS)
 30   CONTINUE 
C
      CALL TBTCLO(TID,ISTATUS)
      CALL STSEPI
C
      END
C
C *** SUBROUTINES ************************************************
C
      SUBROUTINE FIND(X,SDEV,XSTR,XSTP,IPL1,IPL2,IMODE,IMETH,
     +                IFAIL,W1,W2,ACOE,DACOE,CHISQR)
C++++
C. PURPOSE: Find center
C---
      IMPLICIT NONE
      REAL             X(1),SIGMAY(1024),SDEV
      DOUBLE PRECISION XSTR,XSTP
      INTEGER          IPL1,IPL2,IMODE,IMETH
      REAL             XCENTR,PEAK,CHICHK,CHISQR,XSP,XGO
      INTEGER          IFAIL,NPX
      REAL             W1(1),W2(1),ACOE(4),DACOE(4),Y1,Y2
C
      CHICHK = 0.005
      XSP    = REAL(XSTP)
      XGO    = REAL(XSTR) + (IPL1-1)*XSP
      NPX    = IPL2 - IPL1 + 1
      Y1     = X(IPL1)
      Y2     = X(IPL2)
      DO 10 I=1,NPX
       SIGMAY(I)=SDEV
 10   CONTINUE
      IF (IMETH.EQ.-1) THEN                                     ! gauss center
         CALL XGAUS(X(IPL1),SIGMAY,W1,W2,IMODE,NPX,IFAIL,
     +              XGO,XSP,CHICHK,0,ACOE,DACOE,CHISQR)
c     ELSE IF (IMETH)
c      ENDIF
      ENDIF

      RETURN
      END
C
C xgaus : modfied version of  
C @(#)sgaus.for        4.1.1.1 (ESO-IPG) 7/30/92 17:43:00
C
      SUBROUTINE XGAUS(WINDOW,SIGMAY,XBUF,YFIT,IWID,NPIX,
     2                 IWERR,XGO,DXSTP,CHICHK,IOUTPT,A,DA,CHISQR) 
C                                                                              
C LINE CENTER FINDING WITH GAUSSIAN FIT                                       
C                                                                              
C PARAMETERS :                                                               
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                           
C SIGMAY BUFFER WITH PIXEL SDEV
C XBUF WORK BUFFER                                                            
C YFIT WORK BUFFER                                                             
C IWID CODE 0 ABSORPTION, 1 EMISSION                                           
C NPIX NUMBER OF SAMPLES IN WINDOW                                             
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                           
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                      
C DXSTP STEP IN X                                                              
C XCNTR RETURN X CENTER CALCULATED                                             
C CHICHK CHECK CHISQUARE                                                       
C IOUTPT DISPLAY INTERMEDIATE RESULTS 0 NO, 1 YES                              
C AM INTENSITY CENTER PIXEL                                                    
C A ARRAY(4) COEFFICIENTS                
C DA ARRAY(4) STD DEV OF COEFFICIENTS                                      
C                                                                              
      INTEGER I,K1,K2,NPIX,IWID,IWERR,IOUTPT
      INTEGER ITCNT,ITCHK,JER,IBRK
      INTEGER MA,MFIT,NCA,LISTA(4)
      REAL WINDOW(1),XBUF(1),YFIT(1),A(1),DA(1)                                
      REAL COVAR(4,4),ALPHA(4,4)
      REAL XCNTR,XGO,CHICHK
      REAL DXSTP,CHISQR,FLAMDA,OLDCH,DIF,HALF,WIDTH                            
      REAL AM,X,STOP,TOPM
      EXTERNAL FGAUSS
C                                                                              
C BUFFER WITH X VALUES                                                         
C                                                                              
      X      = XGO                                                             
      DO 10 I = 1,NPIX                                                         
          XBUF(I) = XGO + (I-1)*DXSTP                                          
   10 CONTINUE                                                                 
C                                                                              
C FIND INITIAL GUESS                                                           
C                                                                              
      CALL CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,A(2),AM)                     
      IF (IWERR.NE.0) GO TO 120                                                
      A(4)   = (WINDOW(1)+WINDOW(NPIX))/2.                                     
      A(1)   = AM - A(4)                                                       
C                                                                              
C CALCULATE HALF WIDTH                                                         
C                                                                              
      HALF   = A(1)/2. + A(4)                                                  
C                                                                              
C CALCULATION OF FWHM DEPENDS ON SIGN OF THE LINE                              
C                                                                              
      IF (IWID.NE.1) THEN                                                      
          DO 20 I = 1,NPIX                                                     
              IF (WINDOW(I).LT.HALF) GO TO 30                                  
   20     CONTINUE                                                             
   30     K1     = I                                                           
          DO 40 I = K1,NPIX                                                    
              IF (WINDOW(I).GT.HALF) GO TO 50                                  
   40     CONTINUE                                                             
   50     K2     = I                                                           
                                                                               
      ELSE                                                                     
          DO 60 I = 1,NPIX                                                     
              IF (WINDOW(I).GT.HALF) GO TO 70                                  
   60     CONTINUE                                                             
   70     K1     = I                                                           
          DO 80 I = K1,NPIX                                                    
              IF (WINDOW(I).LT.HALF) GO TO 90                                  
   80     CONTINUE                                                             
   90     K2     = I                                                           
      END IF                                                                   
                                                                               
      WIDTH  = ABS(FLOAT(K2-K1)*DXSTP)                                         
      A(3)   = WIDTH/2.354                                                     
      OLDCH  = 9.E16

      MA=4
      MFIT=4
      NCA=4

      DO 300 I=1,MFIT
       LISTA(I)=I
 300  CONTINUE
                                                                 
      ITCNT  = 0                                                               
      ITCHK  = 50                                                              
C            
C init fitting routine
C
      FLAMDA = -1.0                                                           
      CALL MRQMIN(XBUF,WINDOW,SIGMAY,NPIX,A,MA,LISTA,MFIT,COVAR,
     +                  ALPHA,NCA,CHISQR,FGAUSS,FLAMDA)              
C
C iterate 50 times maximum
C               
 100  CALL MRQMIN(XBUF,WINDOW,SIGMAY,NPIX,A,MA,LISTA,MFIT,COVAR,
     +                  ALPHA,NCA,CHISQR,FGAUSS,FLAMDA)              
C                                                                              
C check for convergence                                      
C                       
      DIF    = OLDCH - CHISQR                                                  
      STOP   = DIF/CHISQR                                                      
      OLDCH  = CHISQR                                                          
      ITCNT  = ITCNT + 1                                                       
      IF (ITCNT.GT.ITCHK) GO TO 120                                            
      IF (STOP.GT.CHICHK) GO TO 100                                            
C     
C final call to get results
C
      FLAMDA=0
      CALL MRQMIN(XBUF,WINDOW,SIGMAY,NPIX,A,MA,LISTA,MFIT,COVAR,
     +                  ALPHA,NCA,CHISQR,FGAUSS,FLAMDA)              
C      
      XCNTR  = A(2)            
C     use normalized chisqr
      CHISQR = CHISQR/(NPIX-MA)                                                
C     compute sdev
      DO 200 I=1,MFIT
       DA(I)=SQRT(COVAR(I,I))
 200  CONTINUE
      A(3)   = A(3)*2.345         
      DA(3)  = DA(3)*2.345                                             
C                                                                              
C last check that we are within the window                                     
C                                                                              
      TOPM   = XBUF(NPIX)                                                      
      IF (DXSTP.LT.0.) THEN                                                    
         IF ((XCNTR.GT.XGO) .OR. (XCNTR.LT.TOPM)) GO TO 120 
        ELSE                                                                  
         IF ((XCNTR.LT.XGO) .OR. (XCNTR.GT.TOPM)) GO TO 120                   
      END IF                                                                  
                                                                               
      IWERR  = 0                                                               
      RETURN                                                                   
C                                                                              
C error return                                                                 
C                                                                              
  120 IWERR  = 1                                                               
      RETURN                                                                   
      END                                                                      
C
      SUBROUTINE MRQMIN(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,
     *    COVAR,ALPHA,NCA,CHISQ,FUNCS,ALAMDA)
      PARAMETER (MMAX=20)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MA),
     *  COVAR(NCA,NCA),ALPHA(NCA,NCA),ATRY(MMAX),BETA(MMAX),DA(MMAX)
      EXTERNAL FUNCS
      IF(ALAMDA.LT.0.)THEN
        KK=MFIT+1
        DO 12 J=1,MA
          IHIT=0
          DO 11 K=1,MFIT
            IF(LISTA(K).EQ.J)IHIT=IHIT+1
11        CONTINUE
          IF (IHIT.EQ.0) THEN
            LISTA(KK)=J
            KK=KK+1
          ELSE IF (IHIT.GT.1) THEN
            PAUSE 'Improper permutation in LISTA'
          ENDIF
12      CONTINUE
        IF (KK.NE.(MA+1)) PAUSE 'Improper permutation in LISTA'
        ALAMDA=0.001
        CALL MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,NCA,CHISQ,F
     *UNCS)
        OCHISQ=CHISQ
        DO 13 J=1,MA
          ATRY(J)=A(J)
13      CONTINUE
      ENDIF
      DO 15 J=1,MFIT
        DO 14 K=1,MFIT
          COVAR(J,K)=ALPHA(J,K)
14      CONTINUE
        COVAR(J,J)=ALPHA(J,J)*(1.+ALAMDA)
        DA(J)=BETA(J)
15    CONTINUE
      CALL GAUSSJ(COVAR,MFIT,NCA,DA,1,1)
      IF(ALAMDA.EQ.0.)THEN
        CALL COVSRT(COVAR,NCA,MA,LISTA,MFIT)
        RETURN
      ENDIF
      DO 16 J=1,MFIT
        ATRY(LISTA(J))=A(LISTA(J))+DA(J)
16    CONTINUE
      CALL MRQCOF(X,Y,SIG,NDATA,ATRY,MA,LISTA,MFIT,COVAR,DA,NCA,CHISQ,FU
     *NCS)
      IF(CHISQ.LT.OCHISQ)THEN
        ALAMDA=0.1*ALAMDA
        OCHISQ=CHISQ
        DO 18 J=1,MFIT
          DO 17 K=1,MFIT
            ALPHA(J,K)=COVAR(J,K)
17        CONTINUE
          BETA(J)=DA(J)
          A(LISTA(J))=ATRY(LISTA(J))
18      CONTINUE
      ELSE
        ALAMDA=10.*ALAMDA
        CHISQ=OCHISQ
      ENDIF
      RETURN
      END
C
      SUBROUTINE MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,NALP,
     *CHISQ,FUNCS)
      PARAMETER (MMAX=20)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),ALPHA(NALP,NALP),BETA(MA),
     *    DYDA(MMAX),LISTA(MFIT),A(MA)
      EXTERNAL FUNCS
      DO 12 J=1,MFIT
        DO 11 K=1,J
          ALPHA(J,K)=0.
11      CONTINUE
        BETA(J)=0.
12    CONTINUE
      CHISQ=0.
      DO 15 I=1,NDATA
        CALL FUNCS(X(I),A,YMOD,DYDA,MA)
        SIG2I=1./(SIG(I)*SIG(I))
        DY=Y(I)-YMOD
        DO 14 J=1,MFIT
          WT=DYDA(LISTA(J))*SIG2I
          DO 13 K=1,J
            ALPHA(J,K)=ALPHA(J,K)+WT*DYDA(LISTA(K))
13        CONTINUE
          BETA(J)=BETA(J)+DY*WT
14      CONTINUE
        CHISQ=CHISQ+DY*DY*SIG2I
15    CONTINUE
      DO 17 J=2,MFIT
        DO 16 K=1,J-1
          ALPHA(K,J)=ALPHA(J,K)
16      CONTINUE
17    CONTINUE
      RETURN
      END
C
      SUBROUTINE COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      DIMENSION COVAR(NCVM,NCVM),LISTA(MFIT)
      DO 12 J=1,MA-1
        DO 11 I=J+1,MA
          COVAR(I,J)=0.
11      CONTINUE
12    CONTINUE
      DO 14 I=1,MFIT-1
        DO 13 J=I+1,MFIT
          IF(LISTA(J).GT.LISTA(I)) THEN
            COVAR(LISTA(J),LISTA(I))=COVAR(I,J)
          ELSE
            COVAR(LISTA(I),LISTA(J))=COVAR(I,J)
          ENDIF
13      CONTINUE
14    CONTINUE
      SWAP=COVAR(1,1)
      DO 15 J=1,MA
        COVAR(1,J)=COVAR(J,J)
        COVAR(J,J)=0.
15    CONTINUE
      COVAR(LISTA(1),LISTA(1))=SWAP
      DO 16 J=2,MFIT
        COVAR(LISTA(J),LISTA(J))=COVAR(1,J)
16    CONTINUE
      DO 18 J=2,MA
        DO 17 I=1,J-1
          COVAR(I,J)=COVAR(J,I)
17      CONTINUE
18    CONTINUE
      RETURN
      END
C
      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP)
      PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) PAUSE 'Singular matrix.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
C
      SUBROUTINE FGAUSS(X,A,Y,DYDA,NA)
      DIMENSION A(NA),DYDA(NA)
      Y=0.
      DO 11 I=1,NA-1,4
        ARG=(X-A(I+1))/A(I+2)
        EX=EXP(-0.5*(ARG**2))
        FAC=A(I)*EX*ARG
        Y=Y+A(I+3)+A(1)*EX
        DYDA(I)=EX
        DYDA(I+1)=FAC/A(I+2)
        DYDA(I+2)=FAC*ARG/A(I+2)
        DYDA(I+3)=1.
11    CONTINUE
      RETURN
      END


C @(#)cntrh.for        6.1.1.1 (ESO-IPG) 7/16/93 18:57:59
      SUBROUTINE CNTRH(WINDOW,NPIX,IWID,IWERR,XGO,DXSTP,XCNTR,AM)        
C                                                                        
C CENTER OF LINE FOUND BY SIMPLE MAXIMUM WITHIN A WINDOW                
C                                                                        
C PARAMETERS :                                                            
C WINDOW BUFFER WITH EXPECTED LINE CENTER IN MIDDLE                      
C NPIX NUMBER OF SAMPLES IN WINDOW                                       
C IWID CODE 0 ABSORPTION, 1 EMISSION                                     
C IWERR  ERROR RETURN, 0 OK, 1 ERROR                                      
C XGO XCOORDINATE FIRST ELEMENT IN WINDOW                                 
C DXSTP STEP IN X                                                          
C XCNTR RETURN X CENTER CALCULATED                                         
C AM INTENSITY CENTER PIXEL                                                   
C                                                                     
      IMPLICIT NONE
C
      REAL    WINDOW(1), AM
      INTEGER NPIX, IWID, IWERR
      REAL    XGO, DXSTP, XCNTR
C
      INTEGER IPN, I
C
      IWERR  = 0                                                         
      AM     = WINDOW(1)                                                 
      IPN    = 1                                                         
      IF (IWID.NE.1) THEN                                                
C                                                                       
C FIND MINIMUM                                                          
C
          DO 10 I = 2,NPIX                                               
              IF (WINDOW(I).LT.AM) THEN                                  
                  AM     = WINDOW(I)                                    
                  IPN    = I                                           
              END IF                                                   
   10     CONTINUE                                                     
      ELSE                                                            
C                                                                      
C FIND MAXIMUM                                                        
C                                                                     
          DO 20 I = 2,NPIX                                                 
              IF (WINDOW(I).GT.AM) THEN                                    
                  AM     = WINDOW(I)                                       
                  IPN    = I                                               
              END IF                                                       
   20     CONTINUE                                                         
      END IF                                                                
C                                                                           
C CHECK RESULT                                                              
C                                                                            
      IF (IPN.EQ.1 .OR. IPN.EQ.NPIX) GO TO 30                                
      XCNTR  = XGO + (IPN-1)*DXSTP                                           
      RETURN                                                                  
C                                                                            
C ERROR RETURN                                                                
C                                                                            
   30 IWERR  = 1                                                               
      RETURN                                              
      END                                                                      

