C @(#)xmoment.for	4.1.1.2 (ESO-IPG)  
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1994 Andreas Kaufer LSW,
C                            all rights reserved
C.IDENTIFICATION: MOMENT
C.PURPOSE:        non-interactive computation of normalized moments of a 
C                 spectral line, output stored in a table
C.LANGUAGE:       F77+ESOext
C.AUTHOR:         A.Kaufer
C.KEYWORDS:       Line, moments
C.ALGORITHM:     
C                
C.INPUT/OUTPUT:   output via table
C                 table columns :
C		  :FILE
C		  :JD24
C                 :M0 :M1 :M2 :M3
C
C.VERSION: 941109  AK  Creation   
C-----------------------------------------------------------------
      PROGRAM   XMOMENT
C
      IMPLICIT  NONE
C
      INTEGER   MADRID
      INTEGER   I1,I2,IACT,IAV,IFAIL,II1,IPX
      INTEGER   IPL1,IPL2,ISEQ,ISTAT
      INTEGER   L,NAXIS,NCOLS,NPIX(2)
      INTEGER   PNTRW,IMNOI
      INTEGER   STATUS,IC(12)
      INTEGER   KUN, KNUL, TID
      INTEGER   IMA,NOENT,NLAST,NEXT
      INTEGER   DACTS,DUN,DNUL,FILECOL
C
      REAL      X1,X2,XLAM
      REAL      VALUE(5)
C
      DOUBLE PRECISION START(2),STEP(2)
      DOUBLE PRECISION XS, DXS, JD24
 
      CHARACTER CNAME*20,TNAME*20,INAME*20,INFO*20
      CHARACTER TABU(5)*16,TABL(5)*16,FORM(5)*6
      CHARACTER CLINE*132,HEAD1*72
      CHARACTER IDENT*72,CUNIT*48

      INCLUDE   'MID_INCLUDE:ST_DEF.INC/NOLIST' 
      INCLUDE   'MID_INCLUDE:PLTDEC.INC/NOLIST' 
      COMMON    /VMR/MADRID(1)
      INCLUDE   'MID_INCLUDE:ST_DAT.INC/NOLIST' 
C
      DATA      NCOLS/5/
      DATA      TABU/' ',' ',' ',' ',' '/
      DATA      TABL/'JD24','M0','M1','M2','M3'/
      DATA      FORM/'F10.4','F10.3','F10.3','F10.2','F10.1'/
      DATA      HEAD1/
     2  '                                                       '/
C
 9000 FORMAT(A10,F10.4,2F10.3,F10.2,F10.1)
C
C  *** initialize MIDAS        ***************************************
C
      CALL STSPRO('XMOMENT')  
C
C  *** get parameters *************************************************
C
C  **** name of catalog
C
      CALL STKRDC('P1',1,1,20,IACT,INFO,KUN,KNUL,STATUS)
      L     = INDEX(INFO//' ',' ') - 1
      CNAME = INFO(1:L)
C
C **** name of output table
C
      CALL STKRDC('P2',1,1,20,IACT,INFO,KUN,KNUL,STATUS)
      L     = INDEX(INFO//' ',' ') - 1
      TNAME = INFO(1:L)
C
C **** parameters xstart (X1), xend (X2), lamda center (XLAM)
C
       NCOLS=5
       CALL STKRDR('INPUTR',1,1,IACT,X1,KUN,KNUL,STATUS)
       CALL STKRDR('INPUTR',2,1,IACT,X2,KUN,KNUL,STATUS)
       CALL STKRDR('INPUTR',3,1,IACT,XLAM,KUN,KNUL,STATUS)
C
C *** open table for storage of data
C
      CALL TBTINI(TNAME,F_TRANS,F_O_MODE,12,500,TID,STATUS)
C
      CALL TBCINI(TID,D_C_FORMAT,8,'A8',' ','file',FILECOL,STATUS)
      
      DO 20 IAV = 1,NCOLS
        CALL TBCINI(TID,D_R4_FORMAT,1,FORM(IAV),TABU(IAV),
     +              TABL(IAV),IC(IAV),STATUS)
   20 CONTINUE
C
C *** write header
C
      CALL STTPUT(HEAD1,STATUS)
      CALL STTPUT(' ',STATUS)
C     
C *** loop on input - images from catalog
C
      ISEQ = 0
C **** get number of entries in catalog
C
      CALL STCSHO(CNAME,NOENT,NLAST,STATUS)
C
      DO 30 IMA = 1,NOENT
C
C **** read next image from catalog
C
      CALL STCGET(CNAME,0,INFO,IDENT,NEXT,STATUS)
      L     = INDEX(INFO,'.bdf') - 1
      INAME = INFO(1:L)
      CALL STIGET(INAME,D_R4_FORMAT,0,F_IMA_TYPE,2,
     +     NAXIS,NPIX,START,STEP,IDENT,CUNIT,PNTRW,IMNOI,ISTAT) 

      CALL STDRDD(IMNOI,'DTIME',4,1,DACTS,JD24,DUN,DNUL,STATUS)
      VALUE(1) = REAL(JD24)
C
      XS  = START(1)
      DXS = STEP(1)
      II1  = 16*NAXIS
C
      IPL1   = NINT((X1-XS)/DXS) + 1
      IPL2   = NINT((X2-XS)/DXS) + 1
      I1     = MIN(IPL1,IPL2)
      I2     = MAX(IPL1,IPL2)
      IPX    = I2-I1+1
C
C *** compute moments
C
      CALL MOMENT(MADRID(PNTRW),XLAM,XS,DXS,I1,I2,IPX,IFAIL,VALUE,NCOLS)
C       
C     M0 = Wlam (mA) = VALUE(2) 
C     M1 = vrad      = VALUE(3) 
C     M2 = variance  = VALUE(4)
C     M3 = skewness  = VALUE(5) 
C     
      IF (IFAIL.EQ.0) THEN
         ISEQ   = ISEQ + 1
       CALL TBEWRC(TID,ISEQ,FILECOL,INAME,STATUS)
         CALL TBRWRR(TID,ISEQ,NCOLS,IC,VALUE,STATUS)
         WRITE (CLINE,9000) INAME(1:10),VALUE(1),VALUE(2),VALUE(3),
     +                         VALUE(4),VALUE(5)
         CALL STTPUT(CLINE,STATUS)
      END IF
C 
      CALL STFCLO(IMNOI,ISTATUS)
 30   CONTINUE 
C
      CALL TBTCLO(TID,ISTATUS)
      CALL STSEPI
C
      END
C
C *** SUBROUTINES ************************************************
C
C
      SUBROUTINE MOMENT(X,XLAM,XSTR,XSTP,IPL1,IPL2,IPX,IFAIL,
     *                  VALUE,NCOLS)
C
      IMPLICIT NONE
      REAL             X(1),XLAM
      DOUBLE PRECISION XSTR,XSTP
      INTEGER          IPL1,IPL2,IPX,IFAIL,I,J
      REAL             W(999), V(999), L(999)
      REAL             WW, VV, DV, DL, VALUE(NCOLS)      
      REAL             M0,M1,M2,M3
C
C
      DO 10 I = 1,IPX
       J = IPL1+I-1
       W(I) = X(J)
       L(I) = XSTR+(J-1)*XSTP
       V(I) = ((XSTR+(J-1)*XSTP)-XLAM)/XLAM*3.e5
 10   CONTINUE
c       write(6,*)  L(1), V(1),W(1)
c       write(6,*)  L(IPX), V(IPX),W(IPX)
C
      M0 = 0.
      M1 = 0.
      M2 = 0.
      M3 = 0.
C      
      DO 20 I = 2,IPX
       VV = (V(I)+V(I-1))/2.
       DV = V(I)-V(I-1)
       DL = L(I)-L(I-1)
       WW = (W(I)+W(I-1))/2.
C       
       M0 = M0 + VV**0 * (1.- WW) * DL
       M1 = M1 + VV**1 * (1.- WW) * DL
       M2 = M2 + VV**2 * (1.- WW) * DL
       M3 = M3 + VV**3 * (1.- WW) * DL
 20   CONTINUE
C
       VALUE(2) = M0*1000.                ! in milli Angstroms
C
C     normalize by M0 (equivalent width)
C
       VALUE(3) = M1/M0
       VALUE(4) = M2/M0
       VALUE(5) = M3/M0
C
      RETURN
      END
C
